<?php	
  /**
   * Title: JOWAMP_Results.php
   * Description: This file contains the code used to create the web page JOWAMP_Results, where all configured sessions
	 * are listed. On this page the user can choose which result representation he wants to visualize.
   * Copyright: Copyright (c) 2005
   * Company: University of Aveiro / Institute of Telecommunications - Aveiro pole 
   * @author Helder Veiga 
   * @version 2.1
	 * @Last updated: 9-12-2005
 	 *
 	 * Copyright (C) 2005  Helder Veiga 
 	 *
 	 * This program is free software; you can redistribute it and/or
 	 * modify it under the terms of the GNU General Public License
 	 * as published by the Free Software Foundation; either version 2
 	 * of the License, or (at your option) any later version.
 	 *
 	 * This program is distributed in the hope that it will be useful,
 	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 	 * GNU General Public License for more details.  A HTML version of 
 	 * the GNU General Public License can be seen at
 	 * http://www.gnu.org/licenses/gpl.html.
 	 *
	 */
		 							
  // Set the maximum execution time to 5 minutes. Some session has a lot results, so a bigger time of execution is bether.
  set_time_limit(300);
  
	// Report all errors except E_NOTICE, E_STRICT & E_WARNING. 	 
	error_reporting(E_ALL & ~E_NOTICE & ~E_STRICT & ~E_WARNING);
  
	if(!isset($logged_in)){	// Used in EMP site
    session_start();
  	$EMPpage = true; 
		echo "<LINK href='../JOWAMP_files/emp.css' rel=stylesheet>";
  }	
	

/** 
 * This function is used to list all test sessions started on this site and to show the option menu for the result 
 * representation of each individual test session.
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration).
 * @param $TableSS - the table with the configurations of all single test sessions configured on this site.
 * @param $TableCI - the table with the configurations of all confidence interval test sessions configured on this site.
 */

function show_options_menu($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS, $TableCI){

  global $link_url;
	
	$currentTime = getTime();
	
  ?>
	<SPAN class=utitre2>
	<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Active measurement results</STRONG></FONT></P>
	</SPAN>
	<?php 
	  if(substr_count(strtolower($link_url), "jowamp_showpage.php?link="))
		  echo("<form action=\"JOWAMP_ShowPage.php\" method=\"GET\">");
		else	
      echo("<form action=\"JOWAMP_Results.php\" method=\"GET\">");
    	
  mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());

  // Single Sessions
  
	$thereAreSessions = false;
  $sql = " select id, userID, senderAddress, receiverAddress, numberOfPackets, startYear, startMonth, startDate, startHour, startMinute, startSecond from $TableSS";
  $resultado = mysql_db_query($DB_NAME, $sql);
  if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
		$thereAreSessions = true;																						
    echo "<div style='margin-left:20.3pt;margin-right:20.3pt;'>";
		echo "-&nbsp;To see the configuration details of a session click its user ID.<br>";
  	echo "-&nbsp;To see the detailed results of a session choose the result representation (Graph or Table) on the same row of the corresponding session.<br>";
    echo "-&nbsp;To see the detailed results of two or more sessions, at the same time, select the checkbox of the corresponding sessions and the See Details button at the end of this page.";
		echo "</div>";
		
		// Define the queryString to be used to allow the All checkbox selection
		if(isset($_SERVER['QUERY_STRING'])){
		  if(substr_count(strtolower($_SERVER['QUERY_STRING']), "all=1")){
		    $queryString = substr($_SERVER['QUERY_STRING'],strpos(strtolower($_SERVER['QUERY_STRING']), "all=1&")+strlen("all=1&"));
		    $all = $_SERVER['PHP_SELF']."?".$queryString;
		  }else
		    $all = $_SERVER['PHP_SELF']."?All=1&".$_SERVER['QUERY_STRING'];	
		}else	// In case of EMP page
		  $all = $_SERVER['PHP_SELF']."?All=1";
		?>
    <br>
		<p align="center">
		<table align=center border=9>
		<tr bgcolor=#B22222 style="color: #F8F8FF"><td bgcolor=#FFFFFF align=middle><a href=<?php echo $all;?>>All</a></td><td align=middle>User ID</td><td align=middle>Sender Address</td><td align=middle>Receiver Address</td><td align=middle>Packets</td><td align=middle>Start Time</td><td align=middle>Type</td><td align=middle>Result Representation</td></tr>
		<?php
		$NSid = 1;
		while($registo=mysql_fetch_array($resultado)){
		  
			$userID =$registo["userID"];
			$senderAddress = $registo["senderAddress"];
			$receiverAddress = $registo["receiverAddress"];
			$numberOfPackets = $registo["numberOfPackets"];
			// StartTime  
			$startYear = $registo["startYear"];
			$startMonth = $registo["startMonth"];
			$startDate = $registo["startDate"];
			$startHour = $registo["startHour"];
			$startMinute = $registo["startMinute"];
			$startSecond = $registo["startSecond"];
			$startTime = mktime ( $startHour, $startMinute, $startSecond, $startMonth, $startDate, $startYear); //$registo["realStartTime"];
			$ID = $registo[0];
			$NSid = "SS".$ID;
			$resultsFrame = $link_url."".$NSid."=".$ID;

			if(strlen($senderAddress) > 26)  // IP address to long. 
        $senderAddress = substr($senderAddress,0,25)."...";
			if(strlen($receiverAddress) > 26)  // IP address to long. 	
				$receiverAddress = substr($receiverAddress,0,25)."...";
											
			if(($startTime) > $currentTime)  // Session didn't start yet
			  echo("<tr><td> </td><td align=middle><a href=$link_url"."SS=$ID&resultType=2>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$numberOfPackets</td><td align=middle>$startHour:$startMinute:$startSecond $startDate/$startMonth/$startYear</td><td align=middle>SS</td><td align=middle>Not Started yet</td></tr>");		
			else{
			  ?>
				<tr><td><input type=checkbox name=<?php echo $NSid;?> value= <?php echo $ID;?> <?php if(isset($_GET['All'])) echo "CHECKED";?>></td>
				<?php
  			echo("<td align=middle><a href=$link_url"."SS=$ID&resultType=2>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$numberOfPackets</td><td align=middle>$startHour:$startMinute:$startSecond $startDate/$startMonth/$startYear</td><td align=middle>SS</td><td align=middle><a href=$resultsFrame&resultType=0>Graph</a>/<a href=$resultsFrame&resultType=1>Table</a></td></tr>");		
      }		
		}
		
	  mysql_free_result($resultado);
	}

	
  // confidence interval sessions
  
  $sql = " select id, userID, senderAddress, receiverAddress, numberOfPackets, startYear, startMonth, startDate, startHour, startMinute, startSecond from $TableCI";
  $resultado = mysql_db_query($DB_NAME, $sql);
  if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
                                                // we should check num of rows returned. In case $resultado is false, 
                                               // an error can occurre in mysql_num_rows. So we should use them together.
		if(!$thereAreSessions){
      echo "<div style='margin-left:20.3pt;margin-right:20.3pt;'>";
			echo "-&nbsp;To see the configuration details of a session click its user ID.<br>";
  		echo "-&nbsp;To see the detailed results of a session choose the result representation (Graph or Table) on the same row of the corresponding session.<br>";
    	echo "-&nbsp;To see the detailed results of two or more sessions, at the same time, select the checkbox of the corresponding sessions and the See Details button at the end of this page.";
			echo "</div>";?>
    	<br>
			<p align="center">
			<table align=center border=9>
			<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle><a href=<?php echo $_SERVER['PHP_SELF']."?All=1&".$_SERVER['QUERY_STRING'];?>>All</a></td><td align=middle>User ID</td><td align=middle>Sender Address</td><td align=middle>Receiver Address</td><td align=middle>Packets</td><td align=middle>StartTime</td><td align=middle>Type</td><td align=middle>Result Representation</td></tr>
			<?php
	  }
	
		$thereAreSessions = true;
    while($registo=mysql_fetch_array($resultado)){
	  
      $userID =$registo["userID"];
      $senderAddress = $registo["senderAddress"];
      $receiverAddress = $registo["receiverAddress"];
      $numberOfPackets = $registo["numberOfPackets"];
      //StartTime
			$startYear = $registo['startYear'];
			$startMonth = $registo['startMonth'];
			$startDate = $registo['startDate'];
			$startHour = $registo['startHour'];
			$startMinute = $registo['startMinute'];
			$startSecond = $registo['startSecond'];
      $ID = $registo[0];
			$CIid = "CI".$ID;
			$resultsFrame = $link_url."".$CIid."=".$ID;
	
			if(strlen($senderAddress) > 26)  // IP address to long. 
        $senderAddress = substr($senderAddress,0,25)."...";
			if(strlen($receiverAddress) > 26)  // IP address to long. 	
				$receiverAddress = substr($receiverAddress,0,25)."...";
								
			$startTime = mktime ( $startHour, $startMinute, $startSecond, $startMonth, $startDate, $startYear);
  
	    if(($startTime) > $currentTime)  // Session didn't start yet
			  echo("<tr><td> </td><td align=middle><a href=$link_url"."CI=$ID&resultType=3>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$numberOfPackets</td><td align=middle>$startHour:$startMinute:$startSecond $startDate/$startMonth/$startYear</td><td align=middle>CI</td><td align=middle>Not Started yet</td></tr>");			
			else{
			  ?>
				<tr><td><input type=checkbox name=<?php echo $CIid;?> value= <?php echo $ID;?> <?php if(isset($_GET['All'])) echo "CHECKED";?>></td>
				<?php
  			echo("<td align=middle><a href=$link_url"."CI=$ID&resultType=3>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$numberOfPackets</td><td align=middle>$startHour:$startMinute:$startSecond $startDate/$startMonth/$startYear</td><td align=middle>CI</td><td align=middle><a href=$resultsFrame&resultType=0>Graph</a>/<a href=$resultsFrame&resultType=1>Table</a></td></tr>");			
			}

    }

    mysql_free_result($resultado);
  }
	
	mysql_close();
	
	if(!$thereAreSessions){	
	  echo "</form>";
		echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;There are no sessions results.";
		echo("<br><br><br><br><br><br><br><br><br><br><br><br><br><br>");
  }else{	
		echo("</table></p>");
		echo("<br>");
		?>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Choose which result representation you want to visualize:<br><br>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type=radio name="resultType" value="0" CHECKED/>     Graph<br>
    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type=radio name="resultType" value="1"/>     Table
		
		<?php 
		  if(substr_count(strtolower($link_url), "jowamp_showpage.php?link="))
		    echo("<input type=hidden name=\"link\" value=\"JOWAMP_Results.php\"/>");
      ?>				
		<br>
	
		<p align="center"><input type=submit value="See Details"></p><br><br>
		</form>	
		<?php 
	} 
}
?>	


<?php  

/** 
 * This function is used to show the configuration table of a Single Session
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration).
 * @param $TableSS - the table with the configurations of all single test sessions configured on this site.
 */
 
function singleSessionConfiguration($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS){
		
	mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());
	
	$id = $_GET['SS'];

	$sql = " select userID, mbzIPVN, numberOfScheduleSlots, numberOfPackets, senderPort, receiverPort, senderAddress, receiverAddress, paddingLength, startYear, startMonth, startDate, startHour, startMinute, startSecond, timeOut, /*typeP_Descriptor,*/ slotType, slotParameter from $TableSS where id = $id";
  $resultado = mysql_db_query($DB_NAME, $sql) or die('Could not access table: ' . mysql_error());

  $registo=mysql_fetch_array($resultado);
		  
	$userID = $registo["userID"];
	$mbzIPVN = $registo["mbzIPVN"];
	$numberOfScheduleSlots = $registo["numberOfScheduleSlots"];
	$numberOfPackets = $registo["numberOfPackets"];
	$senderPort = $registo["senderPort"];
	$receiverPort = $registo["receiverPort"];
	$senderAddress = $registo["senderAddress"];
	$receiverAddress = $registo["receiverAddress"];
	$paddingLength = $registo["paddingLength"];
	//StartTime
	$startYear = $registo["startYear"];
	$startMonth = $registo["startMonth"];
	$startDate = $registo["startDate"];
	$startHour = $registo["startHour"];
	$startMinute = $registo["startMinute"];
	$startSecond = $registo["startSecond"];
	$timeOut = $registo["timeOut"];   // timOut in seconds
//	$typeP_Descriptor = $registo["typeP_Descriptor"];
	$slotType = $registo["slotType"]; 
	$slotParameter = $registo["slotParameter"];  // slotParameter in seconds 
		
	?>
	<SPAN class=utitre2>
	<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Configuration details for this test session</STRONG></FONT></P>
	</SPAN>
	<p align="center">
	<table align=center border=9>
  <tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle colspan="2">User ID</td><td align=middle colspan="2">SenderAddress</td><td align=middle>ReceiverAddress</td></tr>
	<?php
	
	echo "<tr><td align=middle colspan=\"2\">$userID</td><td align=middle colspan=\"2\">$senderAddress</td><td align=middle>$receiverAddress</td></tr>";
	echo '<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>IPVN</td><td align=middle>Packets</td><td align=middle>SenderPort</td><td align=middle>ReceiverPort</td><td align=middle>PaddingLength</td></tr>';
	echo "<tr><td align=middle>$mbzIPVN</td><td align=middle>$numberOfPackets</td><td align=middle>$senderPort</td><td align=middle>$receiverPort</td><td align=middle>$paddingLength</td></tr>";
	echo '<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>StartTime</td><td align=middle>TimeOut (s)</td><td align=middle>ScheduleSlots</td><td align=middle>SlotType</td><td align=middle>SlotParameter (s)</td></tr>';
  echo "<tr><td align=middle>$startHour:$startMinute:$startSecond $startDate/$startMonth/$startYear</td><td align=middle>$timeOut</td><td align=middle>$numberOfScheduleSlots</td><td align=middle>$slotType</td><td align=middle>$slotParameter</td></tr>";		

	echo("</table></p><br>");	
		
	mysql_free_result($resultado);
  mysql_close();
	
}
?>


<?php   

/** 
 * This function is used to show the configuration table of a confidence interval session.
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration).
 * @param $TableCI - the table with the configurations of all confidence interval test sessions configured on this site.
 */
 
function CIsessionConfiguration($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableCI){
					 
  mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());
	
	$id = $_GET['CI'];

  // confidence interval sessions
 
	$sql = " select userID, mbzIPVN, numberOfScheduleSlots, numberOfPackets, senderAddress, receiverAddress, paddingLength, startYear, startMonth, startDate, startHour, startMinute, startSecond, timeOut, slotType, slotParameter, stopYear, stopMonth, stopDate, stopHour, stopMinute, stopSecond, timeBetweenSetOfTests, numOfTestsInInterval, timeBetweenTests, numIntervals from $TableCI where id=$id";
  $resultado = mysql_db_query($DB_NAME, $sql) or die('Could not access table: ' . mysql_error());

	$registo=mysql_fetch_array($resultado);
		  
	$userID = $registo["userID"];
	$mbzIPVN = $registo["mbzIPVN"];
	$numberOfScheduleSlots = $registo["numberOfScheduleSlots"];
	$numberOfPackets = $registo["numberOfPackets"];
	$senderAddress = $registo["senderAddress"];
	$receiverAddress = $registo["receiverAddress"];
	$paddingLength = $registo["paddingLength"];
	//StartTime
	$startYear = $registo['startYear'];
	$startMonth = $registo['startMonth'];
	$startDate = $registo['startDate'];
	$startHour = $registo['startHour'];
	$startMinute = $registo['startMinute'];
	$startSecond = $registo['startSecond'];
	$timeOut = $registo["timeOut"];  // timOut in seconds
	//$typeP_Descriptor = $registo["typeP_Descriptor"];
	$slotType = $registo["slotType"];
	$slotParameter = $registo["slotParameter"];  // slotParameter in seconds
  //StopTime
	$stopYear = $registo['stopYear'];
	$stopMonth = $registo['stopMonth'];
	$stopDate = $registo['stopDate'];
	$stopHour = $registo['stopHour'];
	$stopMinute = $registo['stopMinute'];
	$stopSecond = $registo['stopSecond'];
  $timeBetweenSetOfTests = $registo["timeBetweenSetOfTests"];  // In minutes
  $numOfTestsInInterval = $registo["numOfTestsInInterval"];    
  $timeBetweenTests = $registo["timeBetweenTests"];  // In seconds   
  $numIntervals = $registo["numIntervals"];		
	?>
	<SPAN class=utitre2>
	<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Configuration details for this test session</STRONG></FONT></P>
	</SPAN>
	<p align="center">
	<table align=center border=9>
  <tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle colspan="2">User ID</td><td align=middle colspan="2">SenderAddress</td><td align=middle colspan="2">ReceiverAddress</td><td align=middle>IPVN</td></tr>
	<?php
 	
	echo "<tr><td align=middle colspan=\"2\">$userID</td><td align=middle colspan=\"2\">$senderAddress</td><td align=middle colspan=\"2\">$receiverAddress</td><td align=middle>$mbzIPVN</td></tr>";
	echo '<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>Packets</td><td align=middle>PaddingLength</td><td align=middle colspan="2">StartTime</td><td align=middle colspan="2">StopTime</td><td align=middle>TimeOut (s)</td></tr>';
	echo "<tr><td align=middle>$numberOfPackets</td><td align=middle>$paddingLength</td><td align=middle colspan=\"2\">$startHour:$startMinute:$startSecond $startDate/$startMonth/$startYear</td><td align=middle colspan=\"2\">$stopHour:$stopMinute:$stopSecond $stopDate/$stopMonth/$stopYear</td><td align=middle>$timeOut</td></tr>";
	echo '<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>ScheduleSlots</td><td align=middle>SlotType</td><td align=middle>SlotParameter (s)</td><td align=middle>Interval Between Set<br>Of Tests (min)</td><td align=middle>Interval Between<br>Tests (s)</td><td align=middle>Number of intervals</td><td align=middle>Number Of Test<br>In a Interval</td></tr>';
  echo "<tr><td align=middle>$numberOfScheduleSlots</td><td align=middle>$slotType</td><td align=middle>$slotParameter</td><td align=middle>$timeBetweenSetOfTests</td><td align=middle>$timeBetweenTests</td><td align=middle>$numIntervals</td><td align=middle>$numOfTestsInInterval</td></tr>";		
 
  echo("</table></p><br>");	
 
  mysql_free_result($resultado);
  mysql_close();

}
?>


<?php  

/** 
 * This function is used to show the configuration table of a single session of an confidence interval session.
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration).
 * @param $configTable_CI_ID - table with the initial configurations of a confidence interval session.
 * @param $sidTable_CI_ID - table with the session's SID, senderPort, receiverPort, real start time and total test duration
 * for each individual single session of each interval of a confidence interval session.
 * @param $SSid - the single session id on table $sidTable_CI_ID. 
 */
 
function CIsingleSessionConfiguration($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $configTable_CI_ID, $sidTable_CI_ID,$SSid){
		
	mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());

	$sql = " select userID, mbzIPVN, numberOfScheduleSlots, numberOfPackets, senderAddress, receiverAddress, paddingLength, timeOut, /*typeP_Descriptor,*/ slotType, slotParameter from $configTable_CI_ID where id = 1";
  $resultado = mysql_db_query($DB_NAME, $sql) or die('Could not access table: ' . mysql_error());

  $registo=mysql_fetch_array($resultado);
  mysql_free_result($resultado);
  		  
	$userID = $registo["userID"];
	$mbzIPVN = $registo["mbzIPVN"];
	$numberOfScheduleSlots = $registo["numberOfScheduleSlots"];
	$numberOfPackets = $registo["numberOfPackets"];
	$senderAddress = $registo["senderAddress"];
	$receiverAddress = $registo["receiverAddress"];
	$paddingLength = $registo["paddingLength"];
	$timeOut = $registo["timeOut"];
//	$typeP_Descriptor = $registo["typeP_Descriptor"];
	$slotType = $registo["slotType"]; 
	$slotParameter = $registo["slotParameter"];  // slotParameter in seconds 
	
	// Start Time
	$sql = " SELECT realStartTime, senderPort, receiverPort FROM $sidTable_CI_ID".
				 " WHERE id = $SSid";
  $resultado = mysql_db_query($DB_NAME, $sql);
  if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
	  $registo=mysql_fetch_array($resultado);																						
    $realStartTime = $registo["realStartTime"];
		$senderPort = $registo["senderPort"];
	  $receiverPort = $registo["receiverPort"];
	  $date = getdate($realStartTime/1000);
		$startYear = $date["year"];
  	$startMonth = $date["mon"];
  	$startDate = $date["mday"];
  	$startHour = $date["hours"];
  	$startMinute = $date["minutes"];
  	$startSecond = $date["seconds"];
		mysql_free_result($resultado);
  }else{
		echo("Problem reading from table $sidTable_CI_ID: ". mysql_error());			
		mysql_close();
		break;
	}	 	
		
	?>
	<SPAN class=utitre2>
	<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Configuration details for this test session</STRONG></FONT></P>
	</SPAN>
	<p align="center">
	<table align=center border=9>
  <tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle colspan="2">User ID</td><td align=middle colspan="2">SenderAddress</td><td align=middle>ReceiverAddress</td></tr>
	<?php
	
	echo "<tr><td align=middle colspan=\"2\">$userID</td><td align=middle colspan=\"2\">$senderAddress</td><td align=middle>$receiverAddress</td></tr>";
	echo '<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>IPVN</td><td align=middle>Packets</td><td align=middle>SenderPort</td><td align=middle>ReceiverPort</td><td align=middle>PaddingLength</td></tr>';
	echo "<tr><td align=middle>$mbzIPVN</td><td align=middle>$numberOfPackets</td><td align=middle>$senderPort</td><td align=middle>$receiverPort</td><td align=middle>$paddingLength</td></tr>";
	echo '<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>StartTime</td><td align=middle>TimeOut (s)</td><td align=middle>ScheduleSlots</td><td align=middle>SlotType</td><td align=middle>SlotParameter (s)</td></tr>';
  echo "<tr><td align=middle>$startHour:$startMinute:$startSecond $startDate/$startMonth/$startYear</td><td align=middle>$timeOut</td><td align=middle>$numberOfScheduleSlots</td><td align=middle>$slotType</td><td align=middle>$slotParameter</td></tr>";		

	echo("</table></p><br>");	
		
	mysql_close();
	
}
?>


<?php  // Show the individual packet results of a Single Session in a table. 

/**
 * This function is used in two modes of operations: when it is passed to the funtion only the first 7 arguments 
 * the individual packet results of an individual Single Session, with all configurations on row $SessionConfigID of table 
 * $TableSSconfig, is being requested. When all the 9 arguments are passed to the function it means that the SS 
 * belongs to an interval of a Cofidence Interval session. In this last case the table $TableSSconfig (row 1) 
 * has the numberOfPackets and slotParameter and the table $sidTable_CI_ID (row $sidTable_CI_ID_SSid) has the SID, 
 * totalTimeToWait and realStartTime for this SS. So this function is also used to show the results of a Single 
 * Session of a confidence interval, in a table. 
 * @param $serverAddress - the JOWAMP server's address, used on Fetch-Session operation.
 * @param $NTPserverAddress - NTP server address to be used to get the time reference.
 * @param $updateInterval - The interval duration (in minutes) between two consecutives updates to time reference.
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration and results).
 * @param $TableSSconfig - table with the single session's configurations.
 * @param $SessionConfigID - the id of the single session on table $TableSSconfig.
 * @param $sidTable_CI_ID- table with the session's SID, senderPort, receiverPort, real start time and total test duration
 * for each individual single session of each interval of a confidence interval session.
 * @param $sidTable_CI_ID_SSid - the id of the single session on table sidTable_CI_ID.
 */
 
function processSingleSessionToTable($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSSconfig,$SessionConfigID,$sidTable_CI_ID,$sidTable_CI_ID_SSid){
		
	mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());

	$numargs = func_num_args();
	if($numargs == 9){ // This is a Single Session test. The table $TableSSconfig has all the SS configuration.
	  $sql = "select SID, numberOfPackets, slotParameter, totalTimeToWait, realStartTime from $TableSSconfig where id=$SessionConfigID";
		$resultado = mysql_db_query($DB_NAME, $sql) or die('Could not access table: ' . mysql_error());
		$registo=mysql_fetch_array($resultado);
		mysql_free_result($resultado);
  	$SID = $registo["SID"];
		$numberOfPackets = $registo["numberOfPackets"];
		$slotParameter = $registo["slotParameter"];  // in seconds
  	$totalTimeToWait = $registo["totalTimeToWait"];
		$realStartTime = $registo["realStartTime"];
	}else{  // This is a Single Session test of a confidence interval session. The table $TableSSconfig has 
	        // the numberOfPackets and slotParameter SS configuration. The table $sidTable_CI_ID has the SID, totalTimeToWait
					// and realStartTime for this SS.
		$sql = "select numberOfPackets, slotParameter from $TableSSconfig where id=$SessionConfigID";
  	$resultado = mysql_db_query($DB_NAME, $sql) or die('Could not access table: ' . mysql_error());
		$registo=mysql_fetch_array($resultado);
		mysql_free_result($resultado);				
		$numberOfPackets = $registo["numberOfPackets"];
		$slotParameter = $registo["slotParameter"];  // in seconds 			
	  $sql = "select SID, totalTimeToWait, realStartTime from $sidTable_CI_ID where id=$sidTable_CI_ID_SSid";
  	$resultado = mysql_db_query($DB_NAME, $sql) or die('Could not access table: ' . mysql_error());
		$registo=mysql_fetch_array($resultado);
		mysql_free_result($resultado);
  	$SID = $registo["SID"];
  	$totalTimeToWait = $registo["totalTimeToWait"];
		$realStartTime = $registo["realStartTime"];		
	}
					 
	if(($realStartTime+$totalTimeToWait)/1000 > getTime()){  // Session didn't finish yet. 
	  // Execute FetchSession
	
	  if(strlen($NTPserverAddress) == 0)
	    $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $SID $numberOfPackets $slotParameter $realStartTime $totalTimeToWait";
		else
		  $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $SID $numberOfPackets $slotParameter $realStartTime $totalTimeToWait $NTPserverAddress $updateInterval";	

	  execInBackground("java -classpath ./owamp_protocol OWAMP_FetchClient","$parameters");
		
		sleep(2);  // Sleep for 2 seconds to give time to have results.
	}

	
	// Read the results of the Fetched Session from the database and show then in a table.
	
	$sql = " select sequenceNumber, sendTimestamp, receiveTimestamp, delay from `".$SID."`";
  $resultado = mysql_db_query($DB_NAME, $sql)  or die('Could not access table: ' . mysql_error());

	if($resultado && mysql_num_rows($resultado)){
	  if($_GET['resultType'] == 4){				
		  ?>
  		<SPAN class=utitre2>
  		<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;<?php  echo "Individual packet results for this test session";?></STRONG></FONT></P>
  		</SPAN>
  		<?php
		} 
    ?>
		<p align="center">
		<table align=center border=9>
    <tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>sequenceNumber</td><td align=middle>sentTime</td><td align=middle>receivedTime</td><td align=middle>delay (ms)</td></tr>
    <?php
		
		while($registo=mysql_fetch_array($resultado)){
		  
			$sequenceNumber =$registo["sequenceNumber"];  
			$sendTimestamp = date("G:i:s j/n/Y",$registo["sendTimestamp"]/1000);
			$receiveTimestamp = date("G:i:s j/n/Y",$registo["receiveTimestamp"]/1000);
			if($registo["receiveTimestamp"] != 0)  // If packet wasn't lost use the delay value, otherwise delay should be marked as zero.
			  $delay = round($registo["delay"],3);
			else	
			  $delay = 0;
			
			echo "<tr><td align=middle>$sequenceNumber</td><td align=middle>$sendTimestamp</td><td align=middle>$receiveTimestamp</td><td align=middle>$delay</td></tr>";		
		}
		echo("</table></p><br>");
		mysql_free_result($resultado);
	}else{
		mysql_close();
	  return false;	
	}
	
	mysql_close();
	
	return true;
}
?>


<?php  

/** 
 * This function is used to show the results statistics of single sessions in a table.
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration and results).
 * @param $TableSS - the table with the configurations of all single test sessions configured on this site.
 */
 
function processSingleSessionStatisticsToTable($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS){

  global $link_url;
	
	$currentTime = getTime();
	
	mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());
	
	// Get the number of Single sessions
				 
  $sql = " select MAX(id) from $TableSS";
  $resultado = mysql_db_query($DB_NAME, $sql); //or die('Could not access table: ' . mysql_error());
	
	if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
		$registo = mysql_fetch_array($resultado);
		mysql_free_result($resultado);
  	$MaxId = $registo[0];  //  number of Single sessions
  	
  	// For each Single session selected show results statistics in a table
  	
  	$thereAreSingleSession = false;
		$error = false;
		$errorNA = false;
  	for($id=1;$id<=$MaxId;$id++){
  	  if(!empty($_GET['SS'.$id])){
  	    
  	    // Read the results of the Fetched Session from the database and show the average delay in a table.
  	
  	    $sql = " select userID, senderAddress, receiverAddress, numberOfPackets, paddingLength, startYear, startMonth, startDate, startHour, startMinute, startSecond, SID, totalTimeToWait, realStartTime from $TableSS where id = $id";
        $resultado = mysql_db_query($DB_NAME, $sql) or die('Could not access table: ' . mysql_error());
  
        $registo=mysql_fetch_array($resultado);
  		  
  	    $userID =$registo["userID"];
  	    $senderAddress = $registo["senderAddress"];
  	    $receiverAddress = $registo["receiverAddress"];
  			$numberOfPackets = $registo["numberOfPackets"];
				$paddingLength = $registo["paddingLength"];
  			$startYear = $registo["startYear"];
  			$startMonth = $registo["startMonth"];
  			$startDate = $registo["startDate"];
  			$startHour = $registo["startHour"];
  			$startMinute = $registo["startMinute"];
  			$startSecond = $registo["startSecond"];
  			$SID = $registo["SID"];
  			$totalTimeToWait = $registo["totalTimeToWait"];
  			$realStartTime = $registo["realStartTime"];
  			
				if(strlen($userID) > 15)  // User ID to long. 
          $userID = substr($userID,0,15)."...";
					
				if(strlen($senderAddress) > 15)  // IP address to long.
          $senderAddress = substr($senderAddress,0,15)."...";
				if(strlen($receiverAddress) > 15)  // IP address to long.	
					$receiverAddress = substr($receiverAddress,0,15)."...";
										
  	    if(!$thereAreSingleSession){
  			  $thereAreSingleSession = true;
					?>
  				<SPAN class=utitre2>
  				<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Single session statistics</STRONG></FONT></P>
  				</SPAN>
					<div style='margin-left:20.3pt;margin-right:20.3pt;'>
					  To see the configuration and the individual packet results of a session click its user ID.<br>
					</div>	
  				<p align="center">
  				<table align=center border=9>
    			<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>User ID</td><td align=middle>SenderAddress</td><td align=middle>ReceiverAddress</td><td align=middle>StartTime</td><td align=middle colspan='2'>Packets<br>Sent/Received</td><td align=middle colspan='3'>Delay (ms)<br>MIN/AVG/MAX</td><td align=middle>Delay<br>Variance</td><td align=middle colspan='2'>Loss ratio<br>Timeout/<br>Not&nbsp;Received</td><td align=middle>Duplication<br>ratio</td><td align=middle>Throughput<br>(bytes/s)</td></tr>
    			<?php
  			}
  	  
  		  mysql_free_result($resultado);
  		
  		  // Just show statistics of a session if it has finished. 
  			
  		  if(($realStartTime+$totalTimeToWait)/1000 < $currentTime){  // Session has finished
  		    
					// Verify if SS_ResultTable exits. If yes the results statistics for this session are already calculated and 
					// saved in the SS_ResultTable.
					
					$sql = " SELECT numOfPacketsSent, numPacketsReceived, minDelay, averageDelay, maxDelay, varDelay, numTimeoutLosses, numNotReceivedLosses, numDuplicates, throughput FROM SS_ResultTable".
                 " WHERE sid = '".$SID."'"; 
          $resultado = mysql_db_query($DB_NAME, $sql);
					
					if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                                      // we should check num of rows returned. In case $resultado is false, 
		                                                    // an error can occurre in mysql_num_rows. So we should use them together.
         		$resultType = 4;
						
						$registo=mysql_fetch_array($resultado);
						mysql_free_result($resultado);
						
						$numOfPacketsSent = $registo["numOfPacketsSent"]; 
						$numPacketsReceived = $registo["numPacketsReceived"];  // Number of packets received, including packets received after timeOut and duplicates.
						$minDelay = round($registo["minDelay"],3);
						$averageDelay = round($registo["averageDelay"],3); 
						$maxDelay = round($registo["maxDelay"],3);
						$varDelay = round($registo["varDelay"],3);
						// Note: For packet loss and duplication we have their ratio values.
						$numTimeoutLosses = round($registo["numTimeoutLosses"],3);          // loss ratio of packets received after timeout (marked as lost).
						$numNotReceivedLosses = round($registo["numNotReceivedLosses"],3);  // loss ratio of packets sent but not received (lost in the network).
						$numDuplicates = round($registo["numDuplicates"],3);                // Duplication ratio
						$throughput = round($registo["throughput"],3);             
												
						echo "<tr><td align=middle><a href=$link_url"."SS=$id&resultType=$resultType>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$startHour:$startMinute:$startSecond<br>$startDate/$startMonth/$startYear</td><td align=middle>$numOfPacketsSent</td><td align=middle>$numPacketsReceived</td>";						
  				  echo "<td align=middle>$minDelay</td><td align=middle>$averageDelay</td><td align=middle>$maxDelay</td><td align=middle>$varDelay</td><td align=middle>$numTimeoutLosses</td><td align=middle>$numNotReceivedLosses </td><td align=middle>$numDuplicates</td><td align=middle>$throughput</td></tr>";
						
					}else{  // SS_ResultTable doesnt exits, so the statistics results should be calculated.  
					
            // Check if SID entry exits in table SessionDescriptionRecords. If not it means that the fetch-Session isn't finished yet.
        		// This table is used to save the Session Description Record information of all test session fetched. Each row
        		// of	this table represents a fetched session and is identified by the session SID. The Session Description Record 
        		// information of a session only should be saved in this table when the Fetch-Session is complete. So using this 
        		// table we can determine if the Fetch-Session of a test session is finished or not.

  					$sql = " SELECT COUNT(*) AS sidExits FROM SessionDescriptionRecords".
                   " WHERE sid = '".$SID."'"; 
            $resultado = mysql_db_query($DB_NAME, $sql);
 				 		
  					if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
  	                                                      // we should check num of rows returned. In case $resultado is false, 
  		                                                    // an error can occurre in mysql_num_rows. So we should use them together.   
		       		$registo=mysql_fetch_array($resultado);
  						mysql_free_result($resultado);
 				 			
  						if($registo["sidExits"] == 1){  // Fetch-Session finished
              	  	  
  							$sql = " SELECT MIN(ABS(delay)) AS minDelay, AVG(ABS(delay)) AS averageDelay, MAX(ABS(delay)) AS maxDelay from `".$SID."` WHERE receiveTimestamp != 0";
            		$resultado = mysql_db_query($DB_NAME, $sql);
  				  
  							// Verify if table SID exits. If yes, there are results. Otherwise, an error occurred.
    						$i=0;
  							if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
  	                                                          // we should check num of rows returned. In case $resultado is false, 
  		                                                        // an error can occurre in mysql_num_rows. So we should use them together.
           		    $resultType = 4;
   						
  								// Compute min/average/max delay 
  								$registo=mysql_fetch_array($resultado);
  								mysql_free_result($resultado);
  								$minDelay = $registo["minDelay"];
  								$averageDelay = $registo["averageDelay"];  // Will be used to compute variance
  								$maxDelay = $registo["maxDelay"];
																
  								// Compute delay variance
  								$sql = " SELECT delay FROM `".$SID."`".
  						    		   " WHERE receiveTimestamp != 0";
              		$resultado = mysql_db_query($DB_NAME, $sql);
  								while($registo=mysql_fetch_array($resultado)){
      		  	  	  $delay[$i] = abs($registo["delay"]);
      							$i++;
      						}	
  								mysql_free_result($resultado);
  								$varDelay = 0;					
  								for($j=0;$j<$i;$j++){
              	    $varDelay = $varDelay + pow(($delay[$j]-$averageDelay),2);
            			}
            			$varDelay = ($i==1)?$varDelay:$varDelay/($i-1);
   						  						
  						    // Determine the number of packets sent that is equal to $numOfPacketsSent = $numberOfPackets - $numPacketsSkipped. 
  						
  								$numOfSkippedPackets = 0;
  								$numOfPacketsSent = 0;
  						
  								$sql = " SELECT firstSeqnoSkipped, lastSeqnoSkipped from `".$SID."SRD`";
              		$resultado = mysql_db_query($DB_NAME, $sql);
  				  
  					  		// Verify if table SIDSRD has records. If yes, there are skipped records. Otherwise, none packets were skipped.
    				  		if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
  	                                                            // we should check num of rows returned. In case $resultado is false, 
  		                                                          // an error can occurre in mysql_num_rows. So we should use them together.
  							    while($registo=mysql_fetch_array($resultado)){
  							  	  $firstSeqnoSkipped = $registo["firstSeqnoSkipped"];
  										$lastSeqnoSkipped = $registo["lastSeqnoSkipped"];
  										$numOfSkippedPackets = $numOfSkippedPackets + ($lastSeqnoSkipped - $firstSeqnoSkipped + 1);
  									}	
   				   				mysql_free_result($resultado);		
  								}

  								mysql_free_result($resultado);
            
									// Next Seqno indicates the next sequence number that would have been
            			// sent from this send session. For completed sessions, this will equal
            			// NumPackets from the Request-Session.  So we should use its value to
            			// determine the number of packets really sent instead of using the 
            			// numberOfPackets configured in the Request-Session. This information is only
            			// available if the session has terminated. 
            			// Note: For sessions stopped before their total duration, neitheir all of the packets are sent.

									$sql = " SELECT nextSeqno from SessionDescriptionRecords WHERE SID = '".$SID."'";
              		$resultado = mysql_db_query($DB_NAME, $sql);
            			$registo=mysql_fetch_array($resultado);
            			$numOfPacketsSent = $registo["nextSeqno"] - $numOfSkippedPackets;
									mysql_free_result($resultado);									
 
   								// Compute number of packets received (represents all packets received, including packets received after timeOut and duplicates)
  								$sql = "SELECT COUNT(*) AS numPacketsReceived FROM `".$SID."`";
                  $resultado = mysql_db_query($DB_NAME, $sql);
  								$registo=mysql_fetch_array($resultado);
  								$numPacketsReceived = $registo["numPacketsReceived"];   // Number of packets received, including packets received after timeOut and duplicates
  								mysql_free_result($resultado);
									
  								// Compute number of losses (packets received after timeout)
  								$sql = "SELECT COUNT(DISTINCT sequenceNumber) AS numTimeoutLosses FROM `".$SID."` ".
  						           "WHERE receiveTimestamp = 0";
                  $resultado = mysql_db_query($DB_NAME, $sql);
  								$registo=mysql_fetch_array($resultado);
  								// To calculate the numTimeoutLosses, we should calculate its ratio value (numTimeoutLosses/number of packets sent)
                  $numTimeoutLosses = $registo["numTimeoutLosses"]/$numOfPacketsSent;
  								mysql_free_result($resultado);
									  												
  						    // Compute number of loses (packets not received)
  								$sql = "SELECT COUNT(DISTINCT sequenceNumber) AS packetsReceived FROM `".$SID."` ".
  						           "WHERE sequenceNumber >= 0 AND sequenceNumber < ".$numberOfPackets;
                  $resultado = mysql_db_query($DB_NAME, $sql);
  								$registo=mysql_fetch_array($resultado);
									// To calculate the numNotReceivedLosses, we should calculate its ratio value (numNotReceivedLosses/number of packets sent)              			
  								$numNotReceivedLosses = ($numOfPacketsSent - $registo["packetsReceived"])/$numOfPacketsSent;
   				    		mysql_free_result($resultado);
  						
  								// Compute number of Duplicates
  								$sql = "SELECT COUNT(DISTINCT sequenceNumber) AS numDuplicates FROM `".$SID."` ".
  						           "WHERE sequenceNumber IN (SELECT sequenceNumber FROM `".$SID."` ".
  									     "GROUP BY sequenceNumber ".
  									     "HAVING COUNT(sequenceNumber) > 1)";
  						    $resultado = mysql_db_query($DB_NAME, $sql);
									if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
  	                                                          // we should check num of rows returned. In case $resultado is false, 
  		                                                        // an error can occurre in mysql_num_rows. So we should use them together.
           	
  					 			  $registo=mysql_fetch_array($resultado);
										// To calculate the duplicates, we should calculate its ratio value (number of packets duplicated/number of packets sent)
              			$numDuplicates = $registo["numDuplicates"]/$numOfPacketsSent;
   				    		  mysql_free_result($resultado);
									}else{		
									  // Some older versions of MySQL doesn't support this sql statement. So, if $resultado is not set
									  // we should calculate $numDuplicates using the method below:
			
									  $numDuplicates = 0;
                    $sql = "SELECT sequenceNumber FROM `".$SID."`";
                    $resultado = mysql_db_query($DB_NAME, $sql);
										$i = 0;
										while($registo=mysql_fetch_array($resultado)){
      		  	  	    $sequenceNumberArray[$i] = $registo["sequenceNumber"];
      								$i++;
      							}
										$sequenceNumberArrayLength = $i;										
  									mysql_free_result($resultado);
										for($i=0;$i<$numberOfPackets;$i++){
										  $num = 0;
										  for($c=0; $c < $sequenceNumberArrayLength;$c++){
                        if($sequenceNumberArray[$c] == $i) {
												  $num++;
                          if($num == 2){
                            $num = 0;
														$numDuplicates++;												
														break;
													}
                        }
                      }
										}
										// To calculate the duplicates, we should calculate its ratio value (number of packets duplicated/number of packets sent)
              			$numDuplicates = $numDuplicates/$numOfPacketsSent;
									}	
  						 
  						 		// Compute Throughput
  								// Note: Even if packet is marked as received after timeout (receiveTimestamp=0)
              		// we should use them to compute throughput.
  								$sql = " SELECT MIN(sendTimestamp) AS beginTime, MAX(sendTimestamp) AS endTime from `".$SID."`";
            			$resultado = mysql_db_query($DB_NAME, $sql);
  								$registo=mysql_fetch_array($resultado);
  								$beginTime = $registo["beginTime"];  // Used to compute Throughput
  								$endTime = $registo["endTime"];
  								mysql_free_result($resultado);
  						
  								$StreamPackets_Unauthenticated_PACKET_LENGTH = 14;
  								$_OWP_TESTREC_SIZE = 24;
  								$testPacketLength = (($paddingLength + $StreamPackets_Unauthenticated_PACKET_LENGTH) < $_OWP_TESTREC_SIZE)?($_OWP_TESTREC_SIZE):($paddingLength + $StreamPackets_Unauthenticated_PACKET_LENGTH);
  								$throughput = ($testPacketLength * $numOfPacketsSent)/(($endTime-$beginTime)/1000); 
  									 
  								echo "<tr><td align=middle><a href=$link_url"."SS=$id&resultType=$resultType>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$startHour:$startMinute:$startSecond<br>$startDate/$startMonth/$startYear</td><td align=middle>$numOfPacketsSent</td><td align=middle>$numPacketsReceived</td>";						
    				  	  echo "<td align=middle>".round($minDelay,3)."</td><td align=middle>".round($averageDelay,3)."</td><td align=middle>".round($maxDelay,3)."</td><td align=middle>".round($varDelay,3)."</td><td align=middle>".round($numTimeoutLosses,3)."</td><td align=middle>".round($numNotReceivedLosses,3)."</td><td align=middle>".round($numDuplicates,3)."</td><td align=middle>".round($throughput,3)."</td></tr>";
  								
									// Save the results in the SS_ResultTable
									$sql = "INSERT INTO SS_ResultTable ( SID, numOfPacketsSent, numPacketsReceived, minDelay, averageDelay, maxDelay, varDelay, numTimeoutLosses, numNotReceivedLosses, numDuplicates, throughput) VALUES ('".$SID."', $numOfPacketsSent, $numPacketsReceived, $minDelay, $averageDelay, $maxDelay, $varDelay, $numTimeoutLosses, $numNotReceivedLosses, $numDuplicates, $throughput)";
                  mysql_db_query($DB_NAME, $sql) or die('Could not insert results into table: ' . mysql_error());
					
    				    }else{
    				    	$resultType = 2;
  								$error = true;
  								$errorNA = true;
  								echo "<tr><td align=middle><a href=$link_url"."SS=$id&resultType=$resultType>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$startHour:$startMinute:$startSecond<br>$startDate/$startMonth/$startYear</td><td align=middle>NA</td><td align=middle>NA</td>";						
    				  		echo '<td align=middle colspan="10">No results found.</td></tr>';	
    						}
  					 	}else{ // Test-Session finished but SID is not in SessionDescriptionRecords table yet. 
	              echo "<tr><td align=middle><a href=$link_url"."SS=$id&resultType=2>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$startHour:$startMinute:$startSecond<br>$startDate/$startMonth/$startYear</td><td align=middle>NA</td><td align=middle>NA</td>";						
  						  $TIMEOUT = 120; // 2 minutes (120 sec)
								// We should wait for the Fetch-Session results only for 2xTIMEOUT after the test session is finished. If 
								// actual time is less than 2xTIMEOUT from realStartTime+totalTimeToWait 'There are no results yet', else 'No results found'.
				   		  if((($realStartTime+$totalTimeToWait)/1000+2*$TIMEOUT) > $currentTime)  // Wait for Fetch-Session Results (There are no results yet).
     				      echo '<td align=middle colspan="10">There are no results yet.</td></tr>';
								else{  // No results found.
								  $error = true;
									echo '<td align=middle colspan="10">No results found.</td></tr>';
								}			
  						  $errorNA = true;
  					  }	
  					}else{
    				  echo "<tr><td align=middle><a href=$link_url"."SS=$id&resultType=2>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$startHour:$startMinute:$startSecond<br>$startDate/$startMonth/$startYear</td><td align=middle>NA</td><td align=middle>NA</td>";						
  						echo '<td align=middle colspan="10">No results found.</td></tr>';
  						$errorNA = true;
  					}
					}						
  			}else{
  				echo "<tr><td align=middle><a href=$link_url"."SS=$id&resultType=4>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td align=middle>$startHour:$startMinute:$startSecond<br>$startDate/$startMonth/$startYear</td><td align=middle>NA</td><td align=middle>NA</td>";						
					echo '<td align=middle colspan="10">Not finished yet</td></tr>';
					$errorNA = true;
				}	
  				
  	  }
  	}		
  	
  	if($thereAreSingleSession){	
  		echo("</table></p>");
  		if($errorNA){
			  echo "<br><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Table legend:</FONT></STRONG>";
			  echo("<br><br><div style='margin-left:20.3pt;margin-right:20.3pt;'>-&nbsp;&nbsp;'NA': Not Available.</div>");
      }
			if($error){
			  if(!$errorNA)
				  echo "<br><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Table legend:</FONT></STRONG>"; 
  		  echo "<div style='margin-left:20.3pt;margin-right:20.3pt;'>-&nbsp;&nbsp;'No results found': possibly synchronization error.</div>";
			}
			echo("<br><br>");
  	}	
	}	
	mysql_close();

}
?>


<?php  

/** 
 * This function is used to show the results statistics of all parameters (delay,loss,duplication,throughput)of 
 * confidence interval sessions in a table.
 * @param $serverAddress - the JOWAMP server's address, used on CalculateIC operation.
 * @param $NTPserverAddress - NTP server address to be used to get the time reference.
 * @param $updateInterval - The interval duration (in minutes) between two consecutives updates to time reference.
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration and results).
 * @param $TableCI - the table with the configurations of all confidence interval test sessions configured on this site.
 */
 
function processCIresultsToTable($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableCI){

	global $link_url;
	
	$currentTime = getTime();
	
	// Connect to the MySQL database
	
	mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());
  
	// Get the number of CI sessions
	
	$sql = " select MAX(id) from $TableCI";
  $resultado = mysql_db_query($DB_NAME, $sql);//or die('Could not access table: ' . mysql_error());
  if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.	
  	$registo = mysql_fetch_array($resultado);
  	$MaxId = $registo[0];	//  number of CI sessions
  	mysql_free_result($resultado);
  	
  	// For each Single session selected show results statistics in a table
  	
  	$thereAreCISession = false;
  	$error = false;
  	for($id=1;$id<=$MaxId;$id++){
  	  if(!empty($_GET['CI'.$id])){
  	    
  			// Show the table of confidence intervals estatistics
				
				$configTable_CI_ID = "configTable_CI_$id";   // table with the CI session's configuration.
				$sidTable_CI_ID = "sidTable_CI_$id";				 // table with the session's SID, senderPort, receiverPort, 
                                                     // real start time and total test duration for each of the individual 
                                                     // single session of each interval.	
  			$ResultTable_CI_ID = "ResultTable_CI_$id";        // The table with the statistics results of this confidence interval session.
				$SS_ResultTable_CI_ID = "SS_ResultTable_CI_$id";  // Table where the statistic results of all Single Sessions, of each interval, will be saved.
				
  			// Read the user ID, senderAddress and receiverAddress from database jowamp_db
  	    // in table jowamp_CI where id = $ID.
  	
  	    $sql = " select userID, senderAddress, receiverAddress, startYear, startMonth, startDate, startHour, startMinute, startSecond, timeBetweenSetOfTests, numIntervals, numOfTestsInInterval from $TableCI where id = $id";
				
        $resultado = mysql_db_query($DB_NAME, $sql) or die('Could not access table: ' . mysql_error());
  	    if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
  	  	  $registo=mysql_fetch_array($resultado);
  				$userID =$registo["userID"];
  	    	$senderAddress = $registo["senderAddress"];
  	    	$receiverAddress = $registo["receiverAddress"];
					//StartTime
        	$startYear = $registo['startYear'];
        	$startMonth = $registo['startMonth'];
        	$startDate = $registo['startDate'];
        	$startHour = $registo['startHour'];
        	$startMinute = $registo['startMinute'];
        	$startSecond = $registo['startSecond'];
					$timeBetweenSetOfTests = $registo["timeBetweenSetOfTests"];  // in minutes
					$numIntervals = $registo["numIntervals"];
					$numOfTestsInInterval = $registo["numOfTestsInInterval"];
					mysql_free_result($resultado);	 
					
					if(strlen($userID) > 15)  // User ID to long.
            $userID = substr($userID,0,14)."...";
						
					if(strlen($senderAddress) > 15)  // IP address to long.
            $senderAddress = substr($senderAddress,0,14)."...";
					if(strlen($receiverAddress) > 15)  // IP address to long.	
					  $receiverAddress = substr($receiverAddress,0,14)."...";
			    
				}
  	      			 	
  			// Verify if the ResultTable_CI_ID exists. If not calculate CI and sleep for 2 seconds before continuing, because
  			// this is the first time a CalculateCI request is made. So we should wait for results.
  	
  	    $sql = " select id from $ResultTable_CI_ID";
    		$resultado = mysql_db_query($DB_NAME, $sql);// or die('Could not access table: ' . mysql_error());
    		if(!$resultado || !mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
     		  // Calculate the CI. The CI is calculated only if a previous calculate request wasnt made.
                        		
  	      if(strlen($NTPserverAddress) == 0)
					  $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $configTable_CI_ID $sidTable_CI_ID 1 $ResultTable_CI_ID $SS_ResultTable_CI_ID ";
					else	
            $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $configTable_CI_ID $sidTable_CI_ID 1 $ResultTable_CI_ID $SS_ResultTable_CI_ID $NTPserverAddress $updateInterval ";
 					 
  	      execInBackground("java -classpath ./owamp_protocol CalculateCI","$parameters");
 				  sleep(3);
  			}else
  			  mysql_free_result($resultado);
  
		    if(!$thereAreCISession){
			  	$thereAreCISession = true;
					?>
					<SPAN class=utitre2>
			    <P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Multiple sessions (with confidence intervals) statistics</STRONG></FONT></P>
					</SPAN>
					<div style='margin-left:20.3pt;margin-right:20.3pt;'>
					  - To see the configuration and the individual packet results of a session click its user ID.<br>
						- To see the detailed results of an interval click the corresponding interval number.<br>
						- To see the detailed statistical results of a single parameter (delay, loss, duplication or throughput) in a table layout, using a format that is easier to copy, click the corresponding parameter.
					</div>	
					<p align="center">
	    		<table align=center border=9>
    			<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>User ID</td><td align=middle>SenderAddress</td>
					<td align=middle>ReceiverAddress</td><td align=middle>Interval</td><td align=middle>StartTime</td>
					<td align=middle ><a style="color: #F8F8FF" href=<?echo "JOWAMP_Results.php?".$_SERVER['QUERY_STRING']."&parameter=delay align=middle onClick=\"window.open(this,'','toolbar=no,location=no,status=no,menubar=no,titlebar=no,resizable = yes,width=700,height=400,scrollbars=yes'); return false;\"";?>>Average Delay<br>and 90%&nbsp;CI<br>(ms)</a></td>
					<td align=middle><a style="color: #F8F8FF" href=<?echo "JOWAMP_Results.php?".$_SERVER['QUERY_STRING']."&parameter=timeoutLoss align=middle onClick=\"window.open(this,'','toolbar=no,location=no,status=no,menubar=no,titlebar=no,resizable = yes,width=700,height=400,scrollbars=yes'); return false;\"";?>>Average Timeout Loss<br>ratio and 90%&nbsp;CI</a></td>
					<td align=middle><a style="color: #F8F8FF" href=<?echo "JOWAMP_Results.php?".$_SERVER['QUERY_STRING']."&parameter=notReceivedLoss align=middle onClick=\"window.open(this,'','toolbar=no,location=no,status=no,menubar=no,titlebar=no,resizable = yes,width=700,height=400,scrollbars=yes'); return false;\"";?>>Average Not Received Loss<br>ratio and 90%&nbsp;CI</a></td>
					<td align=middle><a style="color: #F8F8FF" href=<?echo "JOWAMP_Results.php?".$_SERVER['QUERY_STRING']."&parameter=duplication align=middle onClick=\"window.open(this,'','toolbar=no,location=no,status=no,menubar=no,titlebar=no,resizable = yes,width=700,height=400,scrollbars=yes'); return false;\"";?>>Average Duplication<br>ratio and 90%&nbsp;CI</a></td>
					<td align=middle><a style="color: #F8F8FF" href=<?echo "JOWAMP_Results.php?".$_SERVER['QUERY_STRING']."&parameter=throughput align=middle onClick=\"window.open(this,'','toolbar=no,location=no,status=no,menubar=no,titlebar=no,resizable = yes,width=700,height=400,scrollbars=yes'); return false;\"";?>>Average Throughput<br>and 90%&nbsp;CI<br>(bytes/s)</a></td></tr>
    			<?php
				}
	
  	    // Read the results of each confidence interval from the table ResultTable_CI_ID and show then in a table.
  	
  			$sql = " SELECT id, averageDelay, minIntervalDelay, maxIntervalDelay, averageTimeoutLosses, varTimeoutLosses, minIntervalTimeoutLosses, maxIntervalTimeoutLosses, averageNotReceivedLosses, varNotReceivedLosses, minIntervalNotReceivedLosses, maxIntervalNotReceivedLosses, averageNumDuplicates, varNumDuplicates, minIntervalNumDuplicates, maxIntervalNumDuplicates, averageThroughput, varThroughput, minIntervalThroughput, maxIntervalThroughput FROM $ResultTable_CI_ID";
      	$resultado = mysql_db_query($DB_NAME, $sql);
			
  	  	if($resultado && mysql_num_rows($resultado)){
				  echo("<tr><td><a href=$link_url"."CI=$id&resultType=5 align=middle>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td></td><td></td><td></td><td></td><td></td><td></td><td></td></tr>");
					$start = mktime ( $startHour, $startMinute, $startSecond, $startMonth, $startDate, $startYear);
					$startTime = date("G:i:s j/n/Y",$start);
					while($registo=mysql_fetch_array($resultado)){
  		  	  $ID = $registo[0];
  			  	$averageDelay = round($registo["averageDelay"],3);
  			  	$minIntervalDelay = round($registo["minIntervalDelay"],3);
  			  	$maxIntervalDelay = round($registo["maxIntervalDelay"],3);
						$averageTimeoutLosses = round($registo["averageTimeoutLosses"],3);
  			  	$minIntervalTimeoutLosses = round($registo["minIntervalTimeoutLosses"],3);
  			  	$maxIntervalTimeoutLosses = round($registo["maxIntervalTimeoutLosses"],3);
						$averageNotReceivedLosses = round($registo["averageNotReceivedLosses"],3);
  			  	$minIntervalNotReceivedLosses = round($registo["minIntervalNotReceivedLosses"],3);
  			  	$maxIntervalNotReceivedLosses = round($registo["maxIntervalNotReceivedLosses"],3);
						$averageNumDuplicates = round($registo["averageNumDuplicates"],3);
  			  	$minIntervalNumDuplicates = round($registo["minIntervalNumDuplicates"],3);
  			  	$maxIntervalNumDuplicates = round($registo["maxIntervalNumDuplicates"],3);
						$averageThroughput = round($registo["averageThroughput"],3);
  			  	$minIntervalThroughput = round($registo["minIntervalThroughput"],3);
  			  	$maxIntervalThroughput = round($registo["maxIntervalThroughput"],3);
  			    ?>
  					<tr><td colspan="3"></td>
  					<?php
  			  	echo "<td align=middle><a href=JOWAMP_Results.php?CI=$id&IntervalId=$ID&numOfTestsInInterval=$numOfTestsInInterval&resultType=6 align=middle onClick=\"window.open(this,'','toolbar=no,location=no,status=no,menubar=no,titlebar=no,resizable = yes,width=700,height=400,scrollbars=yes'); return false;\">$ID</td><td align=middle>$startTime</td><td align=middle>$averageDelay<br>[$minIntervalDelay&nbsp;&nbsp;$maxIntervalDelay]</td><td align=middle>$averageTimeoutLosses<br>[$minIntervalTimeoutLosses&nbsp; $maxIntervalTimeoutLosses]</td><td align=middle>$averageNotReceivedLosses<br>[$minIntervalNotReceivedLosses&nbsp; $maxIntervalNotReceivedLosses]</td><td align=middle>$averageNumDuplicates<br>[$minIntervalNumDuplicates&nbsp; $maxIntervalNumDuplicates]</td><td align=middle>$averageThroughput<br>[$minIntervalThroughput&nbsp;&nbsp;$maxIntervalThroughput]</td></tr>";
						$startTime = date("G:i:s j/n/Y",($start+$ID*($timeBetweenSetOfTests*60)));		
  		  	}
					if(mysql_num_rows($resultado) < $numIntervals){
					  if(($start + $numIntervals*$timeBetweenSetOfTests*60) > $currentTime) // If the test duration isnt finished yet
						  echo '<tr><td colspan="3"></td><td align=middle colspan="7">Not finished yet.</td></tr>';
					  else{	
						  $error = true;
					    echo '<tr><td colspan="3"></td><td align=middle colspan="7">No more results found.</td></tr>';
						}	
					}
  				mysql_free_result($resultado);
  			}else{
				  echo("<tr><td><a href=$link_url"."CI=$id&resultType=3 align=middle>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td></td><td></td><td></td><td></td><td></td><td></td><td></td><tr>");
				  $start = mktime ( $startHour, $startMinute, $startSecond, $startMonth, $startDate, $startYear);
					if(($start + $numIntervals*$timeBetweenSetOfTests*60) > $currentTime) // If the test duration isnt finished yet
					  echo '<tr><td colspan="3"></td><td align=middle colspan="7">There are no results yet.</td></tr>';
					else{	
  					echo '<tr><td colspan="3"></td><td align=middle colspan="7">No results found.</td></tr>';
						$error = true;
					}	
				}
  		}		
  	}	
  	
  	if($thereAreCISession){
  	  echo("</table></p>");
  		if($error){
			  echo "<br><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Table legend:</FONT></STRONG>";
			  echo("<br><br><div style='margin-left:20.3pt;margin-right:20.3pt;'>-&nbsp;&nbsp;'No results found' or 'No more results found': the sessions aren't finished yet or a synchronization error occurred.</div>");
      }
  		echo("<br><br>");
  	}
	}
	mysql_close();

}

?>


<?php  

/** 
 * This function is used to show the results statistics of confidence interval sessions in a table. It only shows the 
 * respective parameter ($_GET['parameter']) and its statistics in the table. In this case the table has tree columms, 
 * one with the minIntervalValue, one with the averageValue and one with the maxIntervalValue parameter statistics. 
 * In this format is easier to copy the table with the statistics.
 * @param $serverAddress - the JOWAMP server's address, used on CalculateIC operation.
 * @param $NTPserverAddress - NTP server address to be used to get the time reference.
 * @param $updateInterval - The interval duration (in minutes) between two consecutives updates to time reference.
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration and results).
 * @param $TableCI - the table with the configurations of all confidence interval test sessions configured on this site.
 */
 
function processCIresultsOfaSingleParameterToTable($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableCI){

	global $link_url;
	
	$currentTime = getTime();
	
	// Connect to the MySQL database
	
	mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());
  
	// Get the number of CI sessions
	
	$sql = " select MAX(id) from $TableCI";
  $resultado = mysql_db_query($DB_NAME, $sql);//or die('Could not access table: ' . mysql_error());
  if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.	
  	$registo = mysql_fetch_array($resultado);
  	$MaxId = $registo[0];	//  number of CI sessions
  	mysql_free_result($resultado);
  	
  	// For each Single session selected show results statistics in a table
  	
  	$thereAreCISession = false;
  	$error = false;
  	for($id=1;$id<=$MaxId;$id++){
  	  if(!empty($_GET['CI'.$id])){
  	    
  			// Show the table of confidence intervals estatistics
				
				$configTable_CI_ID = "configTable_CI_$id";   // table with the CI session's configuration.
				$sidTable_CI_ID = "sidTable_CI_$id";				 // table with the session's SID, senderPort, receiverPort, 
                                                     // real start time and total test duration for each of the individual 
                                                     // single session of each interval.	
  			$ResultTable_CI_ID = "ResultTable_CI_$id";        // The table with the statistics results of this confidence interval session.
				$SS_ResultTable_CI_ID = "SS_ResultTable_CI_$id";  // Table where the statistic results of all Single Sessions, of each interval, will be saved.
				
  			// Read the user ID, senderAddress and receiverAddress from database jowamp_db
  	    // in table jowamp_CI where id = $ID.
  	
  	    $sql = " select userID, senderAddress, receiverAddress, startYear, startMonth, startDate, startHour, startMinute, startSecond, timeBetweenSetOfTests, numIntervals, numOfTestsInInterval from $TableCI where id = $id";
				
        $resultado = mysql_db_query($DB_NAME, $sql) or die('Could not access table: ' . mysql_error());
  	    if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                                    // we should check num of rows returned. In case $resultado is false, 
		                                                  // an error can occurre in mysql_num_rows. So we should use them together.
  	  	  $registo=mysql_fetch_array($resultado);
  				$userID =$registo["userID"];
  	    	$senderAddress = $registo["senderAddress"];
  	    	$receiverAddress = $registo["receiverAddress"];
					//StartTime
        	$startYear = $registo['startYear'];
        	$startMonth = $registo['startMonth'];
        	$startDate = $registo['startDate'];
        	$startHour = $registo['startHour'];
        	$startMinute = $registo['startMinute'];
        	$startSecond = $registo['startSecond'];
					$timeBetweenSetOfTests = $registo["timeBetweenSetOfTests"];  // in minutes
					$numIntervals = $registo["numIntervals"];
					$numOfTestsInInterval = $registo["numOfTestsInInterval"];
					mysql_free_result($resultado);	 
		    
				}
  	      			 	
  			// Verify if the ResultTable_CI_ID exists. If not calculate CI and sleep for 2 seconds before continuing, because
  			// this is the first time a CalculateCI request is made. So we should wait for results.
  	
  	    $sql = " select id from $ResultTable_CI_ID";
    		$resultado = mysql_db_query($DB_NAME, $sql);// or die('Could not access table: ' . mysql_error());
    		if(!$resultado || !mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
     		  // Calculate the CI. The CI is calculated only if a previous calculate request wasnt made.
                        		
  	      if(strlen($NTPserverAddress) == 0)
					  $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $configTable_CI_ID $sidTable_CI_ID 1 $ResultTable_CI_ID $SS_ResultTable_CI_ID ";
					else
					  $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $configTable_CI_ID $sidTable_CI_ID 1 $ResultTable_CI_ID $SS_ResultTable_CI_ID $NTPserverAddress $updateInterval ";	

  	      execInBackground("java -classpath ./owamp_protocol CalculateCI","$parameters");
 				  sleep(3);
  			}else
  			  mysql_free_result($resultado);
  
		    if(!$thereAreCISession){
			  	$thereAreCISession = true;
					?>
					<SPAN class=utitre2>
			    <P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Multiple sessions (with confidence intervals) statistics</STRONG></FONT></P>
					</SPAN>
					<div style='margin-left:20.3pt;margin-right:20.3pt;'>
					  - To see the configuration and the individual packet results of a session click its user ID.<br>
						- To see the detailed results of an interval click the corresponding interval number.
					</div>	
					<p align="center">
	    		<table align=center border=9>
    			<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle rowspan='2'>User ID</td><td align=middle rowspan='2'>SenderAddress</td><td align=middle rowspan='2'>ReceiverAddress</td><td align=middle rowspan='2'>Interval</td><td align=middle rowspan='2'>StartTime</td>
					
					<?php
  			  Switch($_GET['parameter']){
  				  case "delay": 
  					  echo "<td align=middle colspan='3'>Average Delay<br>and 90%&nbsp;CI (ms)</td></tr>";							
  					  break;
  					case "timeoutLoss": 
  					  echo "<td align=middle colspan='3'>Average Timeout Loss<br>ratio and 90%&nbsp;CI</td></tr>";
							break;
  					case "notReceivedLoss": 
  					  echo "<td align=middle colspan='3'>Average Not Received Loss<br>ratio and 90%&nbsp;CI</td></tr>";
							break;
  					case "duplication": 
  					  echo "<td align=middle colspan='3'>Average Duplication<br>ratio and 90%&nbsp;CI</td></tr>";
  						break;
  					case "throughput":
  					  echo "<td align=middle colspan='3'>Average Throughput<br>and 90%&nbsp;CI<br>(bytes/s)</td></tr>";
  						break;
  				}
					echo "<tr bgcolor=#B22222 style=\"color: #F8F8FF\"><td align=middle>AVG</td><td align=middle>[ MIN&nbsp;</td><td align=middle>&nbsp;MAX ]</td></tr>";		
				}
			
  	    // Read the results of each confidence interval from the table ResultTable_CI_ID and show then in a table.

				Switch($_GET['parameter']){
				  case "delay": 
					  $averageParameter = "averageDelay"; 
						$minIntervalParameter = "minIntervalDelay";
						$maxIntervalParameter = "maxIntervalDelay";
					  break;
					case "timeoutLoss": 
					  $averageParameter = "averageTimeoutLosses"; 
						$minIntervalParameter = "minIntervalTimeoutLosses";
						$maxIntervalParameter = "maxIntervalTimeoutLosses";
					  break;
					case "notReceivedLoss": 
					  $averageParameter = "averageNotReceivedLosses"; 
						$minIntervalParameter = "minIntervalNotReceivedLosses";
						$maxIntervalParameter = "maxIntervalNotReceivedLosses";
						break;
					case "duplication": 
					  $averageParameter = "averageNumDuplicates"; 
						$minIntervalParameter = "minIntervalNumDuplicates";
						$maxIntervalParameter = "maxIntervalNumDuplicates";
						break;
					case "throughput":
					  $averageParameter = "averageThroughput"; 
						$minIntervalParameter = "minIntervalThroughput";
						$maxIntervalParameter = "maxIntervalThroughput";
						break;
				}		
				  	
  			$sql = " SELECT id, $averageParameter, $minIntervalParameter, $maxIntervalParameter FROM $ResultTable_CI_ID";
      	$resultado = mysql_db_query($DB_NAME, $sql);
			
  	  	if($resultado && mysql_num_rows($resultado)){
				  echo("<tr><td><a href=$link_url"."CI=$id&resultType=5&parameter=".$_GET['parameter']." align=middle>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td></td><td></td><td></td><td></td><td></td></tr>");
					$start = mktime ( $startHour, $startMinute, $startSecond, $startMonth, $startDate, $startYear);
					$startTime = date("G:i:s j/n/Y",$start);
					while($registo=mysql_fetch_array($resultado)){
  		  	  $ID = $registo[0];
  			  	$averageParameterValue = round($registo[$averageParameter],3);
  			  	$minIntervalParameterValue = round($registo[$minIntervalParameter],3);
  			  	$maxIntervalParameterValue = round($registo[$maxIntervalParameter],3);
  			    ?>
  					<tr><td colspan="3"></td>
  					<?php
  			  	echo "<td align=middle><a href=JOWAMP_Results.php?CI=$id&IntervalId=$ID&numOfTestsInInterval=$numOfTestsInInterval&resultType=6 align=middle onClick=\"window.open(this,'','toolbar=no,location=no,status=no,menubar=no,titlebar=no,resizable = yes,width=700,height=400,scrollbars=yes'); return false;\">$ID</td><td align=middle>$startTime</td><td align=middle>$averageParameterValue</td><td align=middle>$minIntervalParameterValue</td><td align=middle>$maxIntervalParameterValue</td></tr>";
						$startTime = date("G:i:s j/n/Y",($start+$ID*($timeBetweenSetOfTests*60)));		
  		  	}
					if(mysql_num_rows($resultado) < $numIntervals){
					  if(($start + $numIntervals*$timeBetweenSetOfTests*60) > $currentTime) // If the test duration isnt finished yet
						  echo '<tr><td colspan="3"></td><td align=middle colspan="7">Not finished yet.</td></tr>';
					  else{	
						  $error = true;
					    echo '<tr><td colspan="3"></td><td align=middle colspan="7">No more results found.</td></tr>';
						}	
					}
  				mysql_free_result($resultado);
  			}else{
				  echo("<tr><td><a href=$link_url"."CI=$id&resultType=3&parameter=".$_GET['parameter']." align=middle>$userID</a></td><td align=middle>$senderAddress</td><td align=middle>$receiverAddress</td><td></td><td></td><td></td><td></td><td></td><tr>");
				  $start = mktime ( $startHour, $startMinute, $startSecond, $startMonth, $startDate, $startYear);
					if(($start + $numIntervals*$timeBetweenSetOfTests*60) > $currentTime) // If the test duration isnt finished yet
					  echo '<tr><td colspan="3"></td><td align=middle colspan="7">There are no results yet.</td></tr>';
					else{	
  					echo '<tr><td colspan="3"></td><td align=middle colspan="7">No results found.</td></tr>';
						$error = true;
					}	
				}
  		}		
  	}	
  	
  	if($thereAreCISession){
  	  echo("</table></p>");
  		if($error){
			  echo "<br><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Table legend:</FONT></STRONG>";
			  echo("<br><br><div style='margin-left:20.3pt;margin-right:20.3pt;'>-&nbsp;&nbsp;'No results found' or 'No more results found': the sessions aren't finished yet or a synchronization error occurred.</div>");
      }
  		echo("<br><br>");
  	}
	}
	mysql_close();

}

?>

<?php

/** 
 * This function is used to show the results of a single session in a graph.
 * @param $serverAddress - the JOWAMP server's address, used on Fetch-Session operation.
 * @param $NTPserverAddress - NTP server address to be used to get the time reference.
 * @param $updateInterval - The interval duration (in minutes) between two consecutives updates to time reference.
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration and results).
 * @param $TableSS - the table with the configurations of all single test sessions configured on this site.
 */
 
function processSingleSessionToGraph($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS){

  $currentTime = getTime();

	// Connect to the MySQL database
	$connection = mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());

	// Get the number of Single sessions
				 
  $sql = " select MAX(id) from $TableSS";
  $resultado = mysql_db_query($DB_NAME, $sql, $connection);// or die('Could not access table: ' . mysql_error());
	
	if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
	  $registo = mysql_fetch_array($resultado);
		$MaxId = $registo[0];  //  number of Single sessions
	  mysql_free_result($resultado);
		// For each Single session selected show results 
	
		$thereAreSingleSession = false;
		for($id=1;$id<=$MaxId;$id++){
	    if(!empty($_GET['SS'.$id])){
		
		    $sql = " select senderAddress, receiverAddress, SID, numberOfPackets, slotParameter, totalTimeToWait, realStartTime from $TableSS where id = $id";
      	$resultado = mysql_db_query($DB_NAME, $sql, $connection) or die('Could not access table: ' . mysql_error());

      	$registo=mysql_fetch_array($resultado);
		    $senderAddress = $registo["senderAddress"];
 	    	$receiverAddress = $registo["receiverAddress"];
  	  	$totalTimeToWait = $registo["totalTimeToWait"];
				$realStartTime = $registo["realStartTime"];
				$SID = $registo["SID"];
				$numberOfPackets = $registo["numberOfPackets"];
				$slotParameter = $registo["slotParameter"];
			
	    	if(!$thereAreSingleSession){
			    $thereAreSingleSession = true;
					?>
					<SPAN class=utitre2>
					<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Single session results</STRONG></FONT></P>
					</SPAN>
					<?php
				}
	
  	    mysql_free_result($resultado);
		
		  	// Just process fetch session of a session if it has not finished yet because at the end of a session its results
				// are automatically fetched by the Control-Client. This solution also prevents multiple requests to the dataBase.
			
		  	if(($realStartTime+$totalTimeToWait)/1000 > $currentTime){  // Session has not finished yet.
		    
				  // Verify if there are results. If not, this is the first request of results visualization of a user so we 
					// must process a Fetch session. If yes, a previous Fetch Session has already been made so we must not make a new one.
					// Note that when a Fetch session is requested, it will fetch all the results of the session till the end of that session.

				  $sql = " select delay from `".$SID."`";
          $resultado = mysql_db_query($DB_NAME, $sql, $connection);			
  			  if(!$resultado || !mysql_num_rows($resultado)){
				  	// Execute FetchSession
	
						if(strlen($NTPserverAddress) == 0)
	            $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $SID $numberOfPackets $slotParameter $realStartTime $totalTimeToWait";
 						else
						  $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $SID $numberOfPackets $slotParameter $realStartTime $totalTimeToWait $NTPserverAddress $updateInterval";
								
	          execInBackground("java -classpath ./owamp_protocol OWAMP_FetchClient","$parameters");

					  sleep(3);
					}else{
				    mysql_free_result($resultado);
				  }
				}
							
				showSingleSessionGraph("Packet delay x Sequence number","Results between ".$senderAddress." and ".$receiverAddress,"Sequence Number","Delay (ms)",$connection,$DB_NAME,$SID,$senderAddress,$receiverAddress);
	
     }
    }
  }
	mysql_close($connection);
}
?>


<?php   

/** 
 * This function is used to show the results of a confidence interval session in a graph.
 * @param $serverAddress - the JOWAMP server's address, used on Fetch-Session operation.
 * @param $NTPserverAddress - NTP server address to be used to get the time reference.
 * @param $updateInterval - The interval duration (in minutes) between two consecutives updates to time reference.
 * @param $DB_HOSTNAME - it's the data base server's address.
 * @param $DB_USERNAME - user name.
 * @param $DB_PASSWORD - user password.
 * @param $DB_NAME - it's the JOWAMP database name (the database with the session's configuration and results).
 * @param $TableCI - the table with the configurations of all confidence interval test sessions configured on this site.
 */
 
function processCIsessionToGraph($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableCI){
 
	// Connect to the MySQL database
	
	$connection = mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());
  
	// Get the number of CI sessions
	
	$sql = " select MAX(id) from $TableCI";
  $resultado = mysql_db_query($DB_NAME, $sql, $connection);//or die('Could not access table: ' . mysql_error());
  
	if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
		$registo = mysql_fetch_array($resultado);
  	$MaxId = $registo[0];	//  number of CI sessions
  	mysql_free_result($resultado);
  	
  	// For each Single session selected show results statistics in a graph
  	
  	$thereAreCISession = false;
  	
  	for($id=1;$id<=$MaxId;$id++){
  	  if(!empty($_GET['CI'.$id])){
  	    
  			if(!$thereAreCISession){
  			  $thereAreCISession = true;
  			?>
				<SPAN class=utitre2>
  			<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Multiple sessions (with confidence intervals) statistics</STRONG></FONT></P>
  			</SPAN>
  			<?php
  			}
  	
  			// Verify if the ResultTable_CI_ID exists. If not calculate the CI and sleep for 3 seconds before continuing, because
  			// this is the first time a CalculateIC request is made. So we should wait for results.
  	
				$configTable_CI_ID = "configTable_CI_$id";   // table with the CI session's configuration.
				$sidTable_CI_ID = "sidTable_CI_$id";				 // table with the session's SID, senderPort, receiverPort, 
                                                     // real start time and total test duration for each of the individual 
                                                     // single session of each interval.	
  			$ResultTable_CI_ID = "ResultTable_CI_$id";        // The table with the statistics results of this confidence interval session.
				$SS_ResultTable_CI_ID = "SS_ResultTable_CI_$id";  // Table where the statistic results of all Single Sessions, of each interval, will be saved.
																									 				
  	    $sql = " SELECT id FROM $ResultTable_CI_ID";
    		$resultado = mysql_db_query($DB_NAME, $sql, $connection);// or die('Could not access table: ' . mysql_error());
    	  if(!$resultado || !mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
     		  // Calculate the CI. The CI is calculated only if a previous calculate request wasnt made.
  				 
  	      if(strlen($NTPserverAddress) == 0)
					  $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $configTable_CI_ID $sidTable_CI_ID 1 $ResultTable_CI_ID $SS_ResultTable_CI_ID ";
					else	
            $parameters = "$serverAddress $DB_HOSTNAME $DB_NAME $DB_USERNAME $DB_PASSWORD $configTable_CI_ID $sidTable_CI_ID 1 $ResultTable_CI_ID $SS_ResultTable_CI_ID $NTPserverAddress $updateInterval ";
 					 
  	      execInBackground("java -classpath ./owamp_protocol CalculateCI","$parameters");
 				  sleep(3);

  			}else
  			  mysql_free_result($resultado);
 		
				if(isset($_GET['averageDelay'])||isset($_GET['all'])){             // show averageDelay graph
				  $title = "Average delay x Start time";
					$xaxisTitle = "Start time";
					$yaxisTitle = "Average delay (ms)";
					$minInterval = "minIntervalDelay";
					$average = "averageDelay";
					$maxInterval = "maxIntervalDelay";
					showCIGraph($title,$xaxisTitle,$yaxisTitle,$minInterval,$average,$maxInterval,$connection,$DB_NAME,$TableCI,$id);
				}
				if(isset($_GET['averageTimeoutLosses'])||isset($_GET['all'])){     // show averageTimeoutLosses graph
				  $title = "Average timeout loss ratio x Start time";
					$xaxisTitle = "Start time";
					$yaxisTitle = "Average timeout loss ratio";
					$minInterval = "minIntervalTimeoutLosses";
					$average = "averageTimeoutLosses";
					$maxInterval = "maxIntervalTimeoutLosses";
					showCIGraph($title,$xaxisTitle,$yaxisTitle,$minInterval,$average,$maxInterval,$connection,$DB_NAME,$TableCI,$id);
				}
				if(isset($_GET['averageNotReceivedLosses'])||isset($_GET['all'])){ // show aaverageNotReceivedLosses graph
				  $title = "Average not received loss ratio x Start time";
					$xaxisTitle = "Start time";
					$yaxisTitle = "Average not received loss ratio";
					$minInterval = "minIntervalNotReceivedLosses";
					$average = "averageNotReceivedLosses";
					$maxInterval = "maxIntervalNotReceivedLosses";
					showCIGraph($title,$xaxisTitle,$yaxisTitle,$minInterval,$average,$maxInterval,$connection,$DB_NAME,$TableCI,$id);
				}
				if(isset($_GET['averageNumDuplicates'])||isset($_GET['all'])){     // show averageNumDuplicates graph
				  $title = "Average duplication ratio x Start time";
					$xaxisTitle = "Start time";
					$yaxisTitle = "Average duplication ratio";
					$minInterval = "minIntervalNumDuplicates";
					$average = "averageNumDuplicates";
					$maxInterval = "maxIntervalNumDuplicates";
					showCIGraph($title,$xaxisTitle,$yaxisTitle,$minInterval,$average,$maxInterval,$connection,$DB_NAME,$TableCI,$id);
				}
				if(isset($_GET['averageThroughput'])||isset($_GET['all'])){        // show averageThroughput graph
				  $title = "Average throughput x Start time";
					$xaxisTitle = "Start time";
					$yaxisTitle = "Average throughput";
					$minInterval = "minIntervalThroughput";
					$average = "averageThroughput";
					$maxInterval = "maxIntervalThroughput";
					showCIGraph($title,$xaxisTitle,$yaxisTitle,$minInterval,$average,$maxInterval,$connection,$DB_NAME,$TableCI,$id);
				}
 								
 				echo "<br><br>";
      }
    }
  }
	mysql_close($connection); 
}

?>


<?php

/**
 * Function used to show the graph of single sessions individual packet results.
 * @param $title - graph's title.
 * @param $subTitle - graph's subtitle.
 * @param $xaxisTitle - graph's x axis title.
 * @param $yaxisTitle - graph's y axis title.
 * @param $DB_Connection - connection to the database with the session's results.
 * @param $DB_NAME - the name of the database where all session's configurations and results are saved.
 * @param $SIDtable - name of the table with all individual packet results of the session.
 * @param $senderAddress - sender's address.
 * @param $receiverAddress - receiver's address.
 */
  
function showSingleSessionGraph($title,$subTitle,$xaxisTitle,$yaxisTitle,$DB_Connection,$DB_NAME,$SIDtable,$senderAddress,$receiverAddress){

	// Read the results of the Fetched Session from the database and show then in a graph.
		
	$sql = " SELECT sequenceNumber, delay FROM `".$SIDtable."`".
	       " WHERE receiveTimestamp != 0";
  $resultado = mysql_db_query($DB_NAME, $sql, $DB_Connection);
	if($resultado && mysql_num_rows($resultado)){
	  $animation = (mysql_num_rows($resultado) <= 150)?1:0; // Just show animation in graph if num_rows <= 150.
		$anchorRadius = (mysql_num_rows($resultado) <= 150)?"":"anchorRadius='1'"; // If num_rows > 150 decrize anchor size in graph.
	  ?>
		<center>
	  <object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" WIDTH="550" HEIGHT="350" id="FusionCharts" VIEWASTEXT>
	  <PARAM NAME=movie VALUE="Flash/FC_2_3_Line.swf">
	  <PARAM NAME="FlashVars" value="&dataXML=<graph caption='<?php echo $title;?>' subcaption='<?php echo $subTitle;?>' xAxisName='<?php echo $xaxisTitle;?>' yAxisName='<?php echo $yaxisTitle;?>' showNames='1' showValues='0' rotateNames='0' showColumnShadow='1' animation='<?php echo $animation;?>' showAlternateHGridColor='1' AlternateHGridColor='ff5904' divLineColor='ff5904' divLineAlpha='20' alternateHGridAlpha='5' canvasBorderColor='666666' baseFontColor='666666' decimalPrecision='3' <?php echo $anchorRadius;?>>
		<?
		$i=0; 
		while($registo=mysql_fetch_array($resultado)){
			$sequenceNumber =$registo["sequenceNumber"];
			$delay = $registo["delay"];
			echo "<set name='".$sequenceNumber."' value='".$delay."' hoverText='Sequence Number ".$sequenceNumber."' ";
			// Just present 20 values for x axis.
			if(mysql_num_rows($resultado) <= 150)
			  (round(fmod($i,mysql_num_rows($resultado)/20)))?($str = "showName='0'"):($str = "showName='1'");
			else
			  (round(fmod($i,mysql_num_rows($resultado)/10)))?($str = "showName='0'"):($str = "showName='1'");	
			echo $str."/>";		
			$i++;
		}
		?>
		</graph>chartWidth=600&amp;chartHeight=350">
		<PARAM NAME=quality VALUE=high>
		<PARAM NAME=bgcolor VALUE=#FFFFFF>
		<PARAM NAME=WIDTH VALUE=="565"> 
		<PARAM NAME=HEIGHT VALUE="360">                                                   
		<EMBED src="Flash/FC_2_3_Line.swf" FlashVars="&dataXML=<graph caption='<?php echo $title;?>' subcaption='<?php echo $subTitle;?>' xAxisName='<?php echo $xaxisTitle;?>' yAxisName='<?php echo $yaxisTitle;?>' showNames='1' showValues='0' rotateNames='0' showColumnShadow='1' animation='<?php echo $animation;?>' showAlternateHGridColor='1' AlternateHGridColor='ff5904' divLineColor='ff5904' divLineAlpha='20' alternateHGridAlpha='5' canvasBorderColor='666666' baseFontColor='666666' decimalPrecision='3' <?php echo $anchorRadius;?> >
		<?
		mysql_data_seek ($resultado,0);		
		$i=0; 
		while($registo=mysql_fetch_array($resultado)){
			$sequenceNumber =$registo["sequenceNumber"];
			$delay = $registo["delay"];
			echo "<set name='".$sequenceNumber."' value='".$delay."' hoverText='Sequence Number ".$sequenceNumber."' ";
			// Just present 20 values for x axis.
			if(mysql_num_rows($resultado) <= 150)
			  (round(fmod($i,mysql_num_rows($resultado)/20)))?($str = "showName='0'"):($str = "showName='1'");
			else
			  (round(fmod($i,mysql_num_rows($resultado)/10)))?($str = "showName='0'"):($str = "showName='1'");	
			echo $str."/>";		
			$i++;
		}
		?>
		</graph>chartWidth=600&amp;chartHeight=350" quality=high bgcolor=#FFFFFF WIDTH="565" HEIGHT="360" NAME="FC2Column" ALIGN="" TYPE="application/x-shockwave-flash" PLUGINSPAGE="http://www.macromedia.com/go/getflashplayer">
		</EMBED>
		</object>			
		</center>
		<?
		echo("<br><br>");
		mysql_free_result($resultado);
  }else
	  echo "<p align=center>Note: No results found for session between $senderAddress and $receiverAddress (possibly synchronization error).</p><br><br><br><br>";
}
?>

<?php

/**
 * Function used to show the graph of CI sessions results.
 * @param $title - graph's title.
 * @param $xaxisTitle - graph's x axis title.
 * @param $yaxisTitle - graph's y axis title.
 * @param $minInterval - the name of the column, on table ResultTable_CI_ID, corresponding to the minimun interval value
 * of the required statistic (delay, loss, duplication or throughput).
 * @param $average - the name of the column, on table ResultTable_CI_ID, corresponding to the average interval value
 * of the required statistic (delay, loss, duplication or throughput).
 * @param $maxInterval - the name of the column, on table ResultTable_CI_ID, corresponding to the maximun interval 
 * value of the required statistic (delay, loss, duplication or throughput).
 * param $DB_Connection - connection to the database with the session's results.
 * @param $DB_NAME - the name of the database where all session's configurations and results are saved.
 * @param $TableCI - the table with the configurations of all confidence interval test sessions configured on this site. 
 * @param $id - the id of the confidence session on table TableCI.
 */
 
function showCIGraph($title,$xaxisTitle,$yaxisTitle,$minInterval,$average,$maxInterval,$DB_Connection,$DB_NAME,$TableCI,$id){

  $ResultTable_CI_ID = "ResultTable_CI_$id";   // The table with the statistics results of this confidence interval session.  				
  			
  // Read the user ID, senderAddress and receiverAddress from database jowamp_db
  // in table jowamp_IC where id = $ID.
  	
  $sql = " SELECT senderAddress, receiverAddress, startYear, startMonth, startDate, startHour, startMinute, startSecond, timeBetweenSetOfTests, numIntervals FROM $TableCI where id = $id";
	$resultado = mysql_db_query($DB_NAME, $sql, $DB_Connection) or die('Could not access table: ' . mysql_error());
  
	if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
  	$registo=mysql_fetch_array($resultado);
  	$senderAddress = $registo["senderAddress"];
  	$receiverAddress = $registo["receiverAddress"];
		//StartTime
    $startYear = $registo['startYear'];
    $startMonth = $registo['startMonth'];
    $startDate = $registo['startDate'];
    $startHour = $registo['startHour'];
    $startMinute = $registo['startMinute'];
    $startSecond = $registo['startSecond'];
		$timeBetweenSetOfTests = $registo["timeBetweenSetOfTests"];  // in minutes
		$numIntervals = $registo["numIntervals"];
		$start = mktime ( $startHour, $startMinute, $startSecond, $startMonth, $startDate, $startYear);
		mysql_free_result($resultado);	    
	}
  	 
	$subTitle = "Results between ".$senderAddress." and ".$receiverAddress;
						      				
  // Read the results of each confidence interval from the table ResultTable_CI_ID and show then in a Graph.
  
	$sql = " SELECT COUNT(*) AS numResults, MIN($minInterval) AS yAxisMinValue, Max($maxInterval) AS yAxisMaxValue FROM $ResultTable_CI_ID";
  $resultado = mysql_db_query($DB_NAME, $sql, $DB_Connection);
				
  if($resultado && mysql_num_rows($resultado)){
	  
		
		$registo=mysql_fetch_array($resultado);
		$numResults = $registo['numResults'];
		
		if(($numResults==0)&&(($start + $timeBetweenSetOfTests*60) > getTime())){ // If the test duration of first interval isnt finished yet
		  echo "<p align=center>There are no results yet for session between $senderAddress and $receiverAddress (test duration of first interval isn't finished yet).</p><br><br>";
		  mysql_free_result($resultado);
			return;
		}
						
		$yAxisMinValue = round($registo['yAxisMinValue'],3)-0.010;
  	$yAxisMaxValue = round($registo['yAxisMaxValue'],3)+0.010;

    $axisMinMaxValues = "yAxisMinValue='".$yAxisMinValue."' yAxisMaxValue='".$yAxisMaxValue."'";
    
		mysql_free_result($resultado);
			
		$sql = " SELECT id, $average, $minInterval, $maxInterval FROM $ResultTable_CI_ID";
    $resultado = mysql_db_query($DB_NAME, $sql, $DB_Connection);
			
		$startTime = date("G:i:s j/n/Y",$start);
		$animation = (mysql_num_rows($resultado) <= 150)?1:0; // Just show animation in graph if num_rows <= 150.
		$anchorRadius = (mysql_num_rows($resultado) <= 150)?"":"anchorRadius='1'"; // If num_rows > 150 decrize anchor size in graph.
	  ?>
		<center>    	  
		<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" WIDTH="550" HEIGHT="350" id="FusionCharts" VIEWASTEXT>		
		<PARAM NAME=movie VALUE="Flash/FC_2_3_MSLine_2.swf">
		<PARAM NAME="FlashVars" value="&dataXML=<graph caption='<?php echo $title;?>' subcaption='<?php echo $subTitle;?>' xAxisName='<?php echo $xaxisTitle;?>' yAxisName='<?php echo $yaxisTitle;?>' <?php echo $axisMinMaxValues;?> showNames='1' showValues='0' rotateNames='1' showColumnShadow='1' animation='<?php echo $animation;?>' showAlternateHGridColor='1' AlternateHGridColor='ff5904' divLineColor='ff5904' divLineAlpha='20' alternateHGridAlpha='5' canvasBorderColor='666666' baseFontColor='666666' formatNumberScale='1' decimalPrecision='3' showShadow='0' anchorBgColor='ff5904' showLegend='0' <?php echo $anchorRadius;?>>
		<categories>
		<?	
		while($registo=mysql_fetch_array($resultado)){
  		$ID = $registo[0];
  		echo "<category Name='".$startTime."' ";
			// Just present 24 values for x axis.
			(round(fmod(($ID-1),mysql_num_rows($resultado)/24)))?($str = "showName='0'"):($str = "showName='1'");
			echo $str."/>";
  		$startTime = date("G:i:s j/n/Y",($start+$ID*($timeBetweenSetOfTests*60)));		
  	}
		echo "</categories>";
		echo "<dataset seriesName='".$minInterval."' color='FFFFFF' anchorBorderColor='EB4E00' lineThickness='0' anchorSides='10'>";
		mysql_data_seek ($resultado,0);
		while($registo=mysql_fetch_array($resultado)){
  		echo "<set value='".$registo["$minInterval"]."' />";
  	}
		echo "</dataset>";
		echo "<dataset seriesName='".$average."' color='EB4E00' anchorBorderColor='EB4E00' anchorSides='10'>";
		mysql_data_seek ($resultado,0);
		while($registo=mysql_fetch_array($resultado)){
  		echo "<set value='".$registo["$average"]."'/>";
  	}
		echo "</dataset>";		
		echo "<dataset seriesName='".$maxInterval."' color='FFFFFF' anchorBorderColor='EB4E00' lineThickness='0' anchorSides='10'>";
		mysql_data_seek ($resultado,0);
		while($registo=mysql_fetch_array($resultado)){
  		echo "<set value='".$registo["$maxInterval"]."'/>";
  	}		
		?>
		</dataset>
		</graph>chartWidth=600&amp;chartHeight=350">
		<PARAM NAME=quality VALUE=high>
		<PARAM NAME=bgcolor VALUE=#FFFFFF> 
		<PARAM NAME=WIDTH VALUE=="565"> 
		<PARAM NAME=HEIGHT VALUE="360">                                                   
		<EMBED src="Flash/FC_2_3_MSLine_2.swf" FlashVars="&dataXML=<graph caption='<?php echo $title;?>' subcaption='<?php echo $subTitle;?>' xAxisName='<?php echo $xaxisTitle;?>' yAxisName='<?php echo $yaxisTitle;?>' <?php echo $axisMinMaxValues;?> showNames='1' showValues='0' rotateNames='1' showColumnShadow='1' animation='<?php echo $animation;?>' showAlternateHGridColor='1' AlternateHGridColor='ff5904' divLineColor='ff5904' divLineAlpha='20' alternateHGridAlpha='5' canvasBorderColor='666666' baseFontColor='666666' formatNumberScale='1' decimalPrecision='3' showShadow='0' anchorBgColor='ff5904' showLegend='0' <?php echo $anchorRadius;?> >
		<categories>
		<?	
		mysql_data_seek ($resultado,0);
		$startTime = date("G:i:s j/n/Y",$start);
		while($registo=mysql_fetch_array($resultado)){
  		$ID = $registo[0];
  		echo "<category Name='".$startTime."' ";
			// Just present 24 values for x axis.
			(round(fmod(($ID-1),mysql_num_rows($resultado)/24)))?($str = "showName='0'"):($str = "showName='1'");
			echo $str."/>";
  		$startTime = date("G:i:s j/n/Y",($start+$ID*($timeBetweenSetOfTests*60)));		
  	}
		echo "</categories>";
		echo "<dataset seriesName='".$minInterval."' color='FFFFFF' anchorBorderColor='EB4E00' lineThickness='0' anchorSides='10'>";
		mysql_data_seek ($resultado,0);
		while($registo=mysql_fetch_array($resultado)){
  		echo "<set value='".$registo["$minInterval"]."' />";
  	}
		echo "</dataset>";
		echo "<dataset seriesName='".$average."' color='EB4E00' anchorBorderColor='EB4E00' anchorSides='10'>";
		mysql_data_seek ($resultado,0);
		while($registo=mysql_fetch_array($resultado)){
  		echo "<set value='".$registo["$average"]."'/>";
  	}
		echo "</dataset>";		
		echo "<dataset seriesName='".$maxInterval."' color='FFFFFF' anchorBorderColor='EB4E00' lineThickness='0' anchorSides='10'>";
		mysql_data_seek ($resultado,0);
		while($registo=mysql_fetch_array($resultado)){
  		echo "<set value='".$registo["$maxInterval"]."'/>";
  	}		
		?>
		</dataset>
		</graph>chartWidth=600&amp;chartHeight=350" quality=high bgcolor=#FFFFFF WIDTH="565" HEIGHT="360" NAME="FC2Column"
		ALIGN=""
		TYPE="application/x-shockwave-flash" PLUGINSPAGE="http://www.macromedia.com/go/getflashplayer"></EMBED>
		</object>			
		</center>
	  <?	
		mysql_free_result($resultado);
  }else
	  echo "<p align=center>Note: No results found for session between $senderAddress and $receiverAddress (possibly synchronization error).</p><br><br>";

}
?>


<?php
/* In case the graph results of an confidence interval session is requested we should ask the user which results he wants
 * to visualize.
 */
function showMenuForCIresults() {
	?>
	<SPAN class=utitre2>
	<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Choose which confidence interval statistics you want to visualize</STRONG></FONT></P>
	</SPAN>
	<?php 
	
  if(substr_count(strtolower($_SERVER['QUERY_STRING']), "link=jowamp_results.php")) // JOWAMP page
    echo("<form action=\"JOWAMP_ShowPage.php\" method=\"GET\">");
	else	                                                                            // EMP page
    echo("<form action=\"JOWAMP_Results.php\" method=\"GET\">"); 
	?>
	<div style='margin-left:55.3pt;margin-bottom:6.0pt;'>
	  <input type=checkbox name="all" value = "1">&nbsp;&nbsp;&nbsp;All<br>
		<input type=checkbox name="averageDelay" value = "1" CHECKED>&nbsp;&nbsp;&nbsp;Average delay<br>
		<input type=checkbox name="averageTimeoutLosses" value = "1">&nbsp;&nbsp;&nbsp;Average timeout loss ratio<br>
		<input type=checkbox name="averageNotReceivedLosses" value = "1">&nbsp;&nbsp;&nbsp;Average not received loss ratio<br>
		<input type=checkbox name="averageNumDuplicates" value = "1">&nbsp;&nbsp;&nbsp;Average duplication ratio<br>
		<input type=checkbox name="averageThroughput" value = "1">&nbsp;&nbsp;&nbsp;Average throughput<br>
	<?php 

		parse_str($_SERVER['QUERY_STRING'],$output);  // Se the same QUERY_STRING, to do this we have to identify each
    foreach ($output as $name => $value) {        // variable and correspondent values in the QUERY_STRING and use
                                                  // the tag hidn to define them in this form. They will appear in the
			                                            // QUERY_STRING.
	    echo("<input type=hidden name=$name value='$value'/>");
    }	
    ?>				
		<br>
	</div>
		<p align="center"><input type=submit value="Submit"></p><br><br>
		</form>	
	<?php 
}	
?>
	 

<?php

  // The JOWAMP_Results page is all processed starting from this point.
						
	global $link_url;

	if(!isset($EMPpage)){  // JOWAMP web site
 	  $link_url = "JOWAMP_ShowPage.php?link=JOWAMP_Results.php&";
  }else{  // EMP web site
  	$link_url = "JOWAMP_Results.php?";
  }
		
  // Include the Auxiliary Function and constant definition file where all needed functions and constants are definied.
	include("./JOWAMP_Constants.php");
	include("./JOWAMP_AuxiliaryFunctions.php");
	
  if((!isset($_GET['resultType']))||(!substr_count(strtolower($_SERVER['QUERY_STRING']), "ci"))&&(!substr_count(strtolower($_SERVER['QUERY_STRING']), "ss"))){

    show_options_menu($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS, $TableCI);
  	
  }else{
 	
    switch($_GET['resultType']){   
  		
  		case 0:  // Show the graph estatistics
			  // In case the graph results of an confidence interval session is requested we should ask the user which results he wants
        // to visualize. Note: We used all the 6 isset in the if because if a user doesn't selects an option, the menu is presented again.
				if((substr_count(strtolower($_SERVER['QUERY_STRING']), "ci"))&&(!isset($_GET['all']))&&(!isset($_GET['averageDelay']))&&(!isset($_GET['averageTimeoutLosses']))&&(!isset($_GET['averageNotReceivedLosses']))&&(!isset($_GET['averageNumDuplicates']))&&(!isset($_GET['averageThroughput']))){
					showMenuForCIresults();
				}else{
  		    // Single Sessions
  	  	  processSingleSessionToGraph($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS);
  		  
  			  // confidence interval
     		  processCIsessionToGraph($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableCI);
				}
					
  			if(!isset($EMPpage)) // JOWAMP web site
  			  echo("<a href='JOWAMP_ShowPage.php?link=JOWAMP_Results.php'><p align=center>Return Back</p></a><br>");
  			else	// EMP web site
  			  echo("<a href='JOWAMP_Results.php'><p align=center>Return Back</p></a><br>");
  		  break;
  		case 1:  // Show the table estatistics
  		  
  	    if(!isset($_GET['parameter'])){  // Show all parameters and their statistics in the table
    	    // Single Sessions
  		    processSingleSessionStatisticsToTable($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS);
  			
				  // confidence interval
				  processCIresultsToTable($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableCI);
					
 				  if(!isset($EMPpage)) // JOWAMP web site
  			    echo("<a href='JOWAMP_ShowPage.php?link=JOWAMP_Results.php'><p align=center>Return Back</p></a><br>");
  			  else	// EMP web site
  			    echo("<a href='JOWAMP_Results.php'><p align=center>Return Back</p></a><br>");					
		    }else{  // Only show the respective parameter ($_GET['parameter']) and its statistics in the table. In this case
				        // the table has tree columms, one with the minIntervalValue, one with the averageValue and one with the
					      // maxIntervalValue parameter statistics. In this format is easier to copy table with the statistics.
					// confidence interval
					processCIresultsOfaSingleParameterToTable($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableCI);
				}			 
				
  		  break;
  		case 2:  // Show the configuration table of a Single Session
  		  // Single Sessions
  			singleSessionConfiguration($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS);
  			for ($i = 0; $i <= 2; $i++) 
  	      echo "<br>";
  			echo("<a href=".$_SERVER['HTTP_REFERER']."><p align=center>Return Back</p></a><br>");
  			break;
  		case 3:  // Show the configuration table of CI Session
  		  // CI Sessions
  			CIsessionConfiguration($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableCI);
  			echo "<br><br>";
  			echo("<a href=".$_SERVER['HTTP_REFERER']."><p align=center>Return Back</p></a><br>");
  			break;		
  		case 4:  // Show the configuration table and results table of a Single Session
  		  // Single Sessions
  			$ID = $_GET['SS'];
  			singleSessionConfiguration($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS);

				processSingleSessionToTable($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS, $ID);
		
				echo("<a href=".$_SERVER['HTTP_REFERER']."><p align=center>Return Back</p></a><br>");
  			break;
  		case 5:  // Show the configuration table and individual packet results of all single session of each interval
			         // of this CI Session.
  		  // CI Sessions
  
  			CIsessionConfiguration($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableCI);
  					
  		  $ID = $_GET['CI'];

				$configTable_CI_ID = "configTable_CI_$ID";   // table with the CI session's configuration.
				$sidTable_CI_ID = "sidTable_CI_$ID";				 // table with the session's SID, senderPort, receiverPort, 
                                                     // real start time and total test duration for each of the individual 
                                                     // single session of each interval.
																								 				
  			$conn = mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());
 
				$sql = " select id, realStartTime, SID from $sidTable_CI_ID";
        $resultado = mysql_db_query($DB_NAME, $sql, $conn);
  	    if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                              // we should check num of rows returned. In case $resultado is false, 
		                                            // an error can occurre in mysql_num_rows. So we should use them together.
  			  $count=1;
  				$thereIsResults = false;
					$currentTime = getTime();
      		while($registo=mysql_fetch_array($resultado)){
  		  		$ID = $registo[0];
  					$realStartTime = $registo["realStartTime"];
  					$SID = $registo["SID"];
  					
						if(($realStartTime/1000) > $currentTime){  // Session didn't start yet
  					  break;
  					}	
						
  					if($count==1){
								
  						?>
  						<SPAN class=utitre2>
							  <P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;<?php  echo "Individual packet results for this test session";?></STRONG></FONT></P>
  		        </SPAN>
  						<?php
  					}			
  					  					
  					// Verify if table SID exits
  					$sql = " select id from `".$SID."`";
            $resultado2 = mysql_db_query($DB_NAME, $sql, $conn); 
    				if($resultado2){
    					echo('<p align="center">');
    					?>
    					<SPAN class=utitre2>
    					  <P align=center><FONT color=#a51129><STRONG><?php  echo("Session n $count</p>");?></STRONG></FONT></P>
    					</SPAN>
    					<?php
							$TableSSconfig = $configTable_CI_ID;
							$SessionConfigID = 1;
							$sidTable_CI_ID_SSid = $ID;
    					if(processSingleSessionToTable($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSSconfig,$SessionConfigID,$sidTable_CI_ID,$sidTable_CI_ID_SSid))
    					  $thereIsResults = true;
							$count++;	
							echo("<br>");						
							mysql_free_result($resultado2);	
    				}else{
  					  break;								
  					}
  					
  					sleep(1);
  			  }
  				if($thereIsResults)
  				  echo("<a href=".$_SERVER['HTTP_REFERER']."><p align=center>Return Back</p></a><br>");

  			  mysql_free_result($resultado);
				}	
  			mysql_close($conn);
  			break;	
			case 6:  // Show the table with the statistic results of the Single Sessions of one confidence interval.
			
			  $conn = mysql_connect($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD) or die('Problem in the connection to MySQL Server: '. mysql_error());
        
				$CI = $_GET['CI'];          // The ID of the Confidence Interval Session in the jowamp_ci table. 
			  $ID = $_GET['IntervalId'];  // Interval ID of the Confidence Interval Session in the ResultTable_CI_ID.
				$numOfTestsInInterval = $_GET['numOfTestsInInterval'];  // Number of tests in a interval.
 
				$configTable_CI_ID = "configTable_CI_$CI";   // table with the CI session's configuration.
				$sidTable_CI_ID = "sidTable_CI_$CI";				 // table with the session's SID, senderPort, receiverPort, 
                                                     // real start time and total test duration for each of the individual 
                                                     // single session of each interval.				
				$SS_ResultTable_CI_ID = "SS_ResultTable_CI_$CI";   // Table where the statistic results of all Single Sessions, of each interval, are saved.
				
				$IdFirstSS = (($ID-1)*$numOfTestsInInterval + 1);  // Is the id of the first single session in SS_ResultTable_CI_ID for
				                                                   // this interval.
				?>
				<TITLE>J-OWAMP - Measurement Platform</TITLE>
				<SPAN class=utitre2>
				<P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;Single sessions statistics for the <?echo $ID;?> interval of the <?echo $CI;?> multiple sessions </STRONG></FONT></P>
				</SPAN>
			  <div style='margin-left:20.3pt;margin-right:20.3pt;'>
			  To see the configuration and the individual packet results of a session click its ID.<br>
			  </div>	
				<p align="center">
				<table align=center border=9>
				<tr bgcolor=#B22222 style="color: #F8F8FF"><td align=middle>Session ID</td><td align=middle>StartTime</td><td align=middle colspan='2'>Packets<br>Sent/Received</td><td align=middle colspan='3'>Delay (ms)<br>MIN/AVG/MAX</td><td align=middle>Delay<br>Variance</td><td align=middle colspan='2'>Loss ratio<br>Timeout/<br>Not&nbsp;Received</td><td align=middle>Duplication<br>ratio</td><td align=middle>Throughput<br>(bytes/s)</td></tr>
				<?php																								 
				
				for($i=0;$i<$numOfTestsInInterval;$i++){
						
					$sessionId = $IdFirstSS + $i;  // This SS id.	
				  $sql = " SELECT realStartTime FROM $sidTable_CI_ID".
					       " WHERE id = $sessionId";
          $resultado = mysql_db_query($DB_NAME, $sql, $conn);
  	      if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                                      // we should check num of rows returned. In case $resultado is false, 
		                                                    // an error can occurre in mysql_num_rows. So we should use them together.
						$registo=mysql_fetch_array($resultado);																						
  			    $realStartTime = $registo["realStartTime"];
						$date = getdate($realStartTime/1000);
						$startYear = $date["year"];
  					$startMonth = $date["mon"];
  					$startDate = $date["mday"];
  					$startHour = $date["hours"];
  					$startMinute = $date["minutes"];
  					$startSecond = $date["seconds"];
						mysql_free_result($resultado);
  				}else{
					  echo("Problem reading from table $sidTable_CI_ID: ". mysql_error());			
					  mysql_close($conn);
					  break;
					}	 
  											
					$sql = " SELECT numOfPacketsSent, numPacketsReceived, minDelay, averageDelay, maxDelay, varDelay, numTimeoutLosses, numNotReceivedLosses, numDuplicates, throughput FROM $SS_ResultTable_CI_ID".
                 " WHERE id = $sessionId"; 
          $resultado = mysql_db_query($DB_NAME, $sql,$conn);
					
					if($resultado && mysql_num_rows($resultado)){ // In case the table exits, but has no rows $resultado is not false. So
	                                                      // we should check num of rows returned. In case $resultado is false, 
		                                                    // an error can occurre in mysql_num_rows. So we should use them together.
         		$registo=mysql_fetch_array($resultado);
						mysql_free_result($resultado);
						
						$numOfPacketsSent = $registo["numOfPacketsSent"]; 
						$numPacketsReceived = $registo["numPacketsReceived"];  // Number of packets received, including packets received after timeOut and duplicates
						$minDelay = round($registo["minDelay"],3); 
						$averageDelay = round($registo["averageDelay"],3); 
						$maxDelay = round($registo["maxDelay"],3);
						$varDelay = round($registo["varDelay"],3);
						$numTimeoutLosses = round($registo["numTimeoutLosses"],3);          // Number of packets received after timeout (marked as lost).
						$numNotReceivedLosses = round($registo["numNotReceivedLosses"],3);  // Number of packets sent but not received (lost in the network).
						$numDuplicates = round($registo["numDuplicates"],3);
						$throughput = round($registo["throughput"],3);
						
						echo "<tr><td align=middle><a href=$link_url"."SS=$sessionId&CI=$CI&IntervalId=$ID&numOfTestsInInterval=$numOfTestsInInterval&resultType=7>$sessionId</a></td><td align=middle>$startHour:$startMinute:$startSecond<br>$startDate/$startMonth/$startYear</td><td align=middle>$numOfPacketsSent</td><td align=middle>$numPacketsReceived</td>";						
  				  echo "<td align=middle>$minDelay</td><td align=middle>$averageDelay</td><td align=middle>$maxDelay</td><td align=middle>$varDelay</td><td align=middle>$numTimeoutLosses</td><td align=middle>$numNotReceivedLosses </td><td align=middle>$numDuplicates</td><td align=middle>$throughput</td></tr>";

					}else{
					  echo('Problem reading from table $SS_ResultTable_CI_ID: '. mysql_error());			
					  mysql_close($conn);
					  break;
					}	 
				}
				echo("</table></p>");
				mysql_close($conn);
				break;	
			case 7:  // Show the configuration table and results table of a Single Session of an Confidence Interval
  		  // Single Sessions
  			$SSid = $_GET['SS'];        // The SS id in table sidTable_CI_ID for this CI.
				$ID = $_GET['CI'];          // The ID of the Confidence Interval Session in the TableCI table. 
			  $IntervalId = $_GET['IntervalId'];  // Interval ID of the Confidence Interval Session in the ResultTable_CI_ID.
	    	$numOfTestsInInterval = $_GET['numOfTestsInInterval'];  // Number of tests in a interval.
 
				$configTable_CI_ID = "configTable_CI_$ID";   // table with the CI session's configuration.
				$sidTable_CI_ID = "sidTable_CI_$ID";				 // table with the session's SID, senderPort, receiverPort, 
                                                     // real start time and total test duration for each of the individual 
                                                     // single session of each interval.						
				?>
				<TITLE>J-OWAMP - Measurement Platform</TITLE>
				<?
  			CIsingleSessionConfiguration($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $configTable_CI_ID, $sidTable_CI_ID,$SSid);
  			
				?>
  			<SPAN class=utitre2>
				  <P align=left><FONT color=#a51129><STRONG>&nbsp;&nbsp;&nbsp;&nbsp;<?php  echo "Individual packet results for this test session";?></STRONG></FONT></P>
  		  </SPAN>
  			<?php
				
				$TableSSconfig = $configTable_CI_ID;
				$SessionConfigID = 1;
				$sidTable_CI_ID_SSid = $SSid;
				processSingleSessionToTable($serverAddress, $NTPserverAddress, $updateInterval, $DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSSconfig,$SessionConfigID,$sidTable_CI_ID,$sidTable_CI_ID_SSid);
						
				echo("<a href=?CI=$ID&IntervalId=$IntervalId&numOfTestsInInterval=$numOfTestsInInterval&resultType=6><p align=center>Return Back</p></a><br>");
  			break;
  		default:
  			show_options_menu($DB_HOSTNAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME, $TableSS, $TableCI);
  	}
  
  }

?>	